/*!
 * @package     Guest Support
 * @author      RcaTheme.com <support@rcatheme.com>
 * @license     https://www.gnu.org/licenses/gpl-3.0.html GPLv3
 * @link        https://www.rcatheme.com
 * @copyright   2024 RcaTheme.com, All rights resered.
 */
!function(C,n,A,S){"use strict";n=void 0!==n&&n.Math==Math?n:"undefined"!=typeof self&&self.Math==Math?self:Function("return this")(),C.fn.wtanimation=function(){var u,r=C(this),p=r.selector||"",g=(new Date).getTime(),v=[],b=arguments,y=b[0],h=[].slice.call(arguments,1),w="string"==typeof y;n.requestAnimationFrame||n.mozRequestAnimationFrame||n.webkitRequestAnimationFrame||n.msRequestAnimationFrame;return r.each(function(t){var d,s,e,c,i,a,n,o,m,f=C(this),l=this;(m={initialize:function(){d=m.get.settings.apply(l,b),c=d.className,e=d.error,i=d.metadata,o="."+d.namespace,n="module-"+d.namespace,s=f.data(n)||m,a=m.get.animationEndEvent(),w&&(w=m.invoke(y)),!1===w&&(m.verbose("Converted arguments into settings object",d),d.interval?m.delay(d.animate):m.animate(),m.instantiate())},instantiate:function(){m.verbose("Storing instance of module",m),s=m,f.data(n,s)},destroy:function(){m.verbose("Destroying previous module for",l),f.removeData(n)},refresh:function(){m.verbose("Refreshing display type on next animation"),delete m.displayType},forceRepaint:function(){m.verbose("Forcing element repaint");var n=f.parent(),e=f.next();0===e.length?f.detach().appendTo(n):f.detach().insertBefore(e)},repaint:function(){m.verbose("Repainting element");l.offsetWidth},delay:function(n){var e,i=m.get.animationDirection();i||(i=m.can.wtanimation()?m.get.direction():"static"),n=n!==S?n:d.interval,e="auto"==d.reverse&&i==c.outward||1==d.reverse?(r.length-t)*d.interval:t*d.interval,m.debug("Delaying animation by",e),setTimeout(m.animate,e)},animate:function(n){if(d=n||d,!m.is.supported())return m.error(e.support),!1;if(m.debug("Preparing animation",d.animation),m.is.animating()){if(d.queue)return!d.allowRepeats&&m.has.direction()&&m.is.occurring()&&!0!==m.queuing?m.debug("Animation is currently occurring, preventing queueing same animation",d.animation):m.queue(d.animation),!1;if(!d.allowRepeats&&m.is.occurring())return m.debug("Animation is already occurring, will not execute repeated animation",d.animation),!1;m.debug("New animation started, completing previous early",d.animation),s.complete()}m.can.animate()?m.set.animating(d.animation):m.error(e.noAnimation,d.animation,l)},reset:function(){m.debug("Resetting animation to beginning conditions"),m.remove.animationCallbacks(),m.restore.conditions(),m.remove.animating()},queue:function(n){m.debug("Queueing animation of",n),m.queuing=!0,f.one(a+".queue"+o,function(){m.queuing=!1,m.repaint(),m.animate.apply(this,d)})},complete:function(n){m.debug("Animation complete",d.animation),m.remove.completeCallback(),m.remove.failSafe(),m.is.looping()||(m.is.outward()?(m.verbose("Animation is outward, hiding element"),m.restore.conditions(),m.hide()):m.is.inward()?(m.verbose("Animation is outward, showing element"),m.restore.conditions(),m.show()):(m.verbose("Static animation completed"),m.restore.conditions(),d.onComplete.call(l)))},force:{visible:function(){var n=f.attr("style"),e=m.get.userStyle(),i=m.get.displayType(),t=e+"display: "+i+" !important;",a=f.css("display"),o=n===S||""===n;a!==i?(m.verbose("Overriding default display to show element",i),f.attr("style",t)):o&&f.removeAttr("style")},hidden:function(){var n=f.attr("style"),e=f.css("display"),i=n===S||""===n;"none"===e||m.is.hidden()?i&&f.removeAttr("style"):(m.verbose("Overriding default display to hide element"),f.css("display","none"))}},has:{direction:function(n){var i=!1;return"string"==typeof(n=n||d.animation)&&(n=n.split(" "),C.each(n,function(n,e){e!==c.inward&&e!==c.outward||(i=!0)})),i},inlineDisplay:function(){var n=f.attr("style")||"";return C.isArray(n.match(/display.*?;/,""))}},set:{animating:function(n){var e;m.remove.completeCallback(),n=n||d.animation,e=m.get.animationClass(n),m.save.animation(e),m.force.visible(),m.remove.hidden(),m.remove.direction(),m.start.animation(e)},duration:function(n,e){((e="number"==typeof(e=e||d.duration)?e+"ms":e)||0===e)&&(m.verbose("Setting animation duration",e),f.css({"animation-duration":e}))},direction:function(n){(n=n||m.get.direction())==c.inward?m.set.inward():m.set.outward()},looping:function(){m.debug("Wtanionmsg set to loop"),f.addClass(c.looping)},hidden:function(){f.addClass(c.wtanimation).addClass(c.hidden)},inward:function(){m.debug("Setting direction to inward"),f.removeClass(c.outward).addClass(c.inward)},outward:function(){m.debug("Setting direction to outward"),f.removeClass(c.inward).addClass(c.outward)},visible:function(){f.addClass(c.wtanimation).addClass(c.visible)}},start:{animation:function(n){n=n||m.get.animationClass(),m.debug("Starting tween",n),f.addClass(n).one(a+".complete"+o,m.complete),d.useFailSafe&&m.add.failSafe(),m.set.duration(d.duration),d.onStart.call(l)}},save:{animation:function(n){m.cache||(m.cache={}),m.cache.animation=n},displayType:function(n){"none"!==n&&f.data(i.displayType,n)},wtanimationExists:function(n,e){C.fn.wtanimation.exists[n]=e,m.verbose("Saving existence of wtanionmsg",n,e)}},restore:{conditions:function(){var n=m.get.currentAnimation();n&&(f.removeClass(n),m.verbose("Removing animation class",m.cache)),m.remove.duration()}},add:{failSafe:function(){var n=m.get.duration();m.timer=setTimeout(function(){f.triggerHandler(a)},n+d.failSafeDelay),m.verbose("Adding fail safe timer",m.timer)}},remove:{animating:function(){f.removeClass(c.animating)},animationCallbacks:function(){m.remove.queueCallback(),m.remove.completeCallback()},queueCallback:function(){f.off(".queue"+o)},completeCallback:function(){f.off(".complete"+o)},display:function(){f.css("display","")},direction:function(){f.removeClass(c.inward).removeClass(c.outward)},duration:function(){f.css("animation-duration","")},failSafe:function(){m.verbose("Removing fail safe timer",m.timer),m.timer&&clearTimeout(m.timer)},hidden:function(){f.removeClass(c.hidden)},visible:function(){f.removeClass(c.visible)},looping:function(){m.debug("Wtanionmsgs are no longer looping"),m.is.looping()&&(m.reset(),f.removeClass(c.looping))},wtanimation:function(){f.removeClass(c.visible).removeClass(c.hidden)}},get:{settings:function(n,e,i){return"object"==typeof n?C.extend(!0,{},C.fn.wtanimation.settings,n):"function"==typeof i?C.extend({},C.fn.wtanimation.settings,{animation:n,onComplete:i,duration:e}):"string"==typeof e||"number"==typeof e?C.extend({},C.fn.wtanimation.settings,{animation:n,duration:e}):"object"==typeof e?C.extend({},C.fn.wtanimation.settings,e,{animation:n}):"function"==typeof e?C.extend({},C.fn.wtanimation.settings,{animation:n,onComplete:e}):C.extend({},C.fn.wtanimation.settings,{animation:n})},animationClass:function(n){var e=n||d.animation,i=m.can.wtanimation()&&!m.has.direction()?m.get.direction()+" ":"";return c.animating+" "+c.wtanimation+" "+i+e},currentAnimation:function(){return!(!m.cache||m.cache.animation===S)&&m.cache.animation},currentDirection:function(){return m.is.inward()?c.inward:c.outward},direction:function(){return m.is.hidden()||!m.is.visible()?c.inward:c.outward},animationDirection:function(n){var i;return"string"==typeof(n=n||d.animation)&&(n=n.split(" "),C.each(n,function(n,e){e===c.inward?i=c.inward:e===c.outward&&(i=c.outward)})),i||!1},duration:function(n){return!1===(n=n||d.duration)&&(n=f.css("animation-duration")||0),"string"==typeof n?-1<n.indexOf("ms")?parseFloat(n):1e3*parseFloat(n):n},displayType:function(n){return n=n===S||n,d.displayType?d.displayType:(n&&f.data(i.displayType)===S&&m.can.wtanimation(!0),f.data(i.displayType))},userStyle:function(n){return(n=n||f.attr("style")||"").replace(/display.*?;/,"")},wtanimationExists:function(n){return C.fn.wtanimation.exists[n]},animationStartEvent:function(){var n,e=A.createElement("div"),i={animation:"animationstart",OAnimation:"oAnimationStart",MozAnimation:"mozAnimationStart",WebkitAnimation:"webkitAnimationStart"};for(n in i)if(e.style[n]!==S)return i[n];return!1},animationEndEvent:function(){var n,e=A.createElement("div"),i={animation:"animationend",OAnimation:"oAnimationEnd",MozAnimation:"mozAnimationEnd",WebkitAnimation:"webkitAnimationEnd"};for(n in i)if(e.style[n]!==S)return i[n];return!1}},can:{wtanimation:function(n){var e,i,t,a,o,r,s=d.animation,l=m.get.wtanimationExists(s),u=m.get.displayType(!1);if(l===S||n){if(m.verbose("Determining whether animation exists"),e=f.attr("class"),i=f.prop("tagName"),a=(t=C("<"+i+" />").addClass(e).insertAfter(f)).addClass(s).removeClass(c.inward).removeClass(c.outward).addClass(c.animating).addClass(c.wtanimation).css("animationName"),o=t.addClass(c.inward).css("animationName"),u||(u=t.attr("class",e).removeAttr("style").removeClass(c.hidden).removeClass(c.visible).show().css("display"),m.verbose("Determining final display state",u),m.save.displayType(u)),t.remove(),a!=o)m.debug("Direction exists for animation",s),r=!0;else{if("none"==a||!a)return void m.debug("No animation defined in css",s);m.debug("Static animation found",s,u),r=!1}m.save.wtanimationExists(s,r)}return l!==S?l:r},animate:function(){return m.can.wtanimation()!==S}},is:{animating:function(){return f.hasClass(c.animating)},inward:function(){return f.hasClass(c.inward)},outward:function(){return f.hasClass(c.outward)},looping:function(){return f.hasClass(c.looping)},occurring:function(n){return n="."+(n=n||d.animation).replace(" ","."),0<f.filter(n).length},visible:function(){return f.is(":visible")},hidden:function(){return"hidden"===f.css("visibility")},supported:function(){return!1!==a}},hide:function(){m.verbose("Hiding element"),m.is.animating()&&m.reset(),l.blur(),m.remove.display(),m.remove.visible(),m.set.hidden(),m.force.hidden(),d.onHide.call(l),d.onComplete.call(l)},show:function(n){m.verbose("Showing element",n),m.remove.hidden(),m.set.visible(),m.force.visible(),d.onShow.call(l),d.onComplete.call(l)},toggle:function(){m.is.visible()?m.hide():m.show()},stop:function(){m.debug("Stopping current animation"),f.triggerHandler(a)},stopAll:function(){m.debug("Stopping all animation"),m.remove.queueCallback(),f.triggerHandler(a)},clear:{queue:function(){m.debug("Clearing animation queue"),m.remove.queueCallback()}},enable:function(){m.verbose("Starting animation"),f.removeClass(c.disabled)},disable:function(){m.debug("Stopping animation"),f.addClass(c.disabled)},setting:function(n,e){if(m.debug("Changing setting",n,e),C.isPlainObject(n))C.extend(!0,d,n);else{if(e===S)return d[n];C.isPlainObject(d[n])?C.extend(!0,d[n],e):d[n]=e}},internal:function(n,e){if(C.isPlainObject(n))C.extend(!0,m,n);else{if(e===S)return m[n];m[n]=e}},debug:function(){!d.silent&&d.debug&&(d.performance?m.performance.log(arguments):(m.debug=Function.prototype.bind.call(console.info,console,d.name+":"),m.debug.apply(console,arguments)))},verbose:function(){!d.silent&&d.verbose&&d.debug&&(d.performance?m.performance.log(arguments):(m.verbose=Function.prototype.bind.call(console.info,console,d.name+":"),m.verbose.apply(console,arguments)))},error:function(){d.silent||(m.error=Function.prototype.bind.call(console.error,console,d.name+":"),m.error.apply(console,arguments))},performance:{log:function(n){var e,i;d.performance&&(i=(e=(new Date).getTime())-(g||e),g=e,v.push({Name:n[0],Arguments:[].slice.call(n,1)||"",Element:l,"Execution Time":i})),clearTimeout(m.performance.timer),m.performance.timer=setTimeout(m.performance.display,500)},display:function(){var n=d.name+":",i=0;g=!1,clearTimeout(m.performance.timer),C.each(v,function(n,e){i+=e["Execution Time"]}),n+=" "+i+"ms",p&&(n+=" '"+p+"'"),1<r.length&&(n+=" ("+r.length+")"),(console.group!==S||console.table!==S)&&0<v.length&&(console.groupCollapsed(n),console.table?console.table(v):C.each(v,function(n,e){console.log(e.Name+": "+e["Execution Time"]+"ms")}),console.groupEnd()),v=[]}},invoke:function(t,n,e){var a,o,i,r=s;return n=n||h,e=l||e,"string"==typeof t&&r!==S&&(t=t.split(/[\. ]/),a=t.length-1,C.each(t,function(n,e){var i=n!=a?e+t[n+1].charAt(0).toUpperCase()+t[n+1].slice(1):t;if(C.isPlainObject(r[i])&&n!=a)r=r[i];else{if(r[i]!==S)return o=r[i],!1;if(!C.isPlainObject(r[e])||n==a)return r[e]!==S&&(o=r[e]),!1;r=r[e]}})),C.isFunction(o)?i=o.apply(e,n):o!==S&&(i=o),C.isArray(u)?u.push(i):u!==S?u=[u,i]:i!==S&&(u=i),o!==S&&o}}).initialize()}),u!==S?u:this},C.fn.wtanimation.exists={},C.fn.wtanimation.settings={name:"Wtanimation",silent:!1,debug:!1,verbose:!1,performance:!0,namespace:"wtanimation",interval:0,reverse:"auto",onStart:function(){},onComplete:function(){},onShow:function(){},onHide:function(){},useFailSafe:!0,failSafeDelay:100,allowRepeats:!1,displayType:!1,animation:"fade",duration:!1,queue:!0,metadata:{displayType:"display"},className:{animating:"animating",disabled:"disabled",hidden:"hidden",inward:"in",loading:"loading",looping:"looping",outward:"out",wtanimation:"wtanimation",visible:"visible"},error:{noAnimation:"Element is no longer attached to DOM. Unable to animate.  Use silent setting to surpress this warning in production.",repeated:"That animation is already occurring, cancelling repeated animation",method:"The method you called is not defined",support:"This browser does not support CSS animations"}}}(jQuery,window,document);
!function(X,Y,G,J){"use strict";Y=void 0!==Y&&Y.Math==Math?Y:"undefined"!=typeof self&&self.Math==Math?self:Function("return this")(),X.fn.wtdropdown=function(z){var P,W=X(this),H=X(G),j=W.selector||"",N="ontouchstart"in G.documentElement,U=(new Date).getTime(),K=[],B=z,$="string"==typeof B,Q=[].slice.call(arguments,1);return W.each(function(n){var e,t,i,a,s,o,r,v=X.isPlainObject(z)?X.extend(!0,{},X.fn.wtdropdown.settings,z):X.extend({},X.fn.wtdropdown.settings),f=v.className,c=v.message,l=v.fields,m=v.keys,h=v.metadata,u=v.namespace,d=v.regExp,g=v.selector,b=v.error,p=v.templates,w="."+u,x="module-"+u,C=X(this),S=X(v.context),y=C.find(g.text),A=C.find(g.search),T=C.find(g.sizer),k=C.find(g.input),L=C.find(g.icon),I=0<C.prev().find(g.text).length?C.prev().find(g.text):C.prev(),D=C.children(g.menu),R=D.find(g.item),q=!1,O=!1,V=!1,E=this,M=C.data(x),F={initialize:function(){F.debug("Initializing wtddforselect",v),F.is.alreadySetup()?F.setup.reference():(F.setup.layout(),v.values&&F.change.values(v.values),F.refreshData(),F.save.defaults(),F.restore.selected(),F.create.id(),F.bind.events(),F.observeChanges(),F.instantiate())},instantiate:function(){F.verbose("Storing instance of wtddforselect",F),M=F,C.data(x,F)},destroy:function(){F.verbose("Destroying previous wtddforselect",C),F.remove.tabbable(),C.off(w).removeData(x),D.off(w),H.off(a),F.disconnect.menuObserver(),F.disconnect.selectObserver()},observeChanges:function(){"MutationObserver"in Y&&(o=new MutationObserver(F.event.select.mutation),r=new MutationObserver(F.event.menu.mutation),F.debug("Setting up mutation observer",o,r),F.observe.select(),F.observe.menu())},disconnect:{menuObserver:function(){r&&r.disconnect()},selectObserver:function(){o&&o.disconnect()}},observe:{select:function(){F.has.input()&&o.observe(C[0],{childList:!0,subtree:!0})},menu:function(){F.has.menu()&&r.observe(D[0],{childList:!0,subtree:!0})}},create:{id:function(){s=(Math.random().toString(16)+"000000000").substr(2,8),a="."+s,F.verbose("Creating unique id for element",s)},userChoice:function(e){var n,i;return!!(e=e||F.get.userValues())&&(e=X.isArray(e)?e:[e],X.each(e,function(e,t){!1===F.get.item(t)&&(i=v.templates.addition(F.add.variables(c.addResult,t)),i=X("<div />").html(i).attr("data-"+h.value,t).attr("data-"+h.text,t).addClass(f.addition).addClass(f.item),v.hideAdditions&&i.addClass(f.hidden),n=n===J?i:n.add(i),F.verbose("Creating user choices for value",t,i))}),n)},userLabels:function(e){var t=F.get.userValues();t&&(F.debug("Adding user labels",t),X.each(t,function(e,t){F.verbose("Adding custom user value"),F.add.label(t,t)}))},menu:function(){D=X("<div />").addClass(f.menu).appendTo(C)},sizer:function(){T=X("<span />").addClass(f.sizer).insertAfter(A)}},search:function(e){e=e!==J?e:F.get.query(),F.verbose("Searching for query",e),F.has.minCharacters(e)?F.filter(e):F.hide()},select:{firstUnfiltered:function(){F.verbose("Selecting first non-filtered element"),F.remove.selectedItem(),R.not(g.unselectable).not(g.addition+g.hidden).eq(0).addClass(f.selected)},nextAvailable:function(e){var t=(e=e.eq(0)).nextAll(g.item).not(g.unselectable).eq(0),e=e.prevAll(g.item).not(g.unselectable).eq(0);0<t.length?(F.verbose("Moving selection to",t),t.addClass(f.selected)):(F.verbose("Moving selection to",e),e.addClass(f.selected))}},setup:{api:function(){var e={debug:v.debug,urlData:{value:F.get.value(),query:F.get.query()},on:!1};F.verbose("First request, initializing API"),C.api(e)},layout:function(){C.is("select")&&(F.setup.select(),F.setup.returnedObject()),F.has.menu()||F.create.menu(),F.is.search()&&!F.has.search()&&(F.verbose("Adding search input"),A=X("<input />").addClass(f.search).prop("autocomplete","off").insertBefore(y)),F.is.multiple()&&F.is.searchSelection()&&!F.has.sizer()&&F.create.sizer(),v.allowTab&&F.set.tabbable()},select:function(){var e=F.get.selectValues();F.debug("Wtddforselect initialized on a select",e),C.is("select")&&(k=C),0<k.parent(g.wtdropdown).length?(F.debug("UI wtddforselect already exists. Creating wtddforselect menu only"),C=k.closest(g.wtdropdown),F.has.menu()||F.create.menu(),D=C.children(g.menu),F.setup.menu(e)):(F.debug("Creating entire wtddforselect from select"),C=X("<div />").attr("class",k.attr("class")).addClass(f.selection).addClass(f.wtdropdown).html(p.wtdropdown(e)).insertBefore(k),k.hasClass(f.multiple)&&!1===k.prop("multiple")&&(F.error(b.missingMultiple),k.prop("multiple",!0)),k.is("[multiple]")&&F.set.multiple(),k.prop("disabled")&&(F.debug("Disabling wtddforselect"),C.addClass(f.disabled)),k.removeAttr("class").detach().prependTo(C)),F.refresh()},menu:function(e){D.html(p.menu(e,l)),R=D.find(g.item)},reference:function(){F.debug("Wtddforselect behavior was called on select, replacing with closest wtddforselect"),C=C.parent(g.wtdropdown),M=C.data(x),E=C.get(0),F.refresh(),F.setup.returnedObject()},returnedObject:function(){var e=W.slice(0,n),t=W.slice(n+1);W=e.add(C).add(t)}},refresh:function(){F.refreshSelectors(),F.refreshData()},refreshItems:function(){R=D.find(g.item)},refreshSelectors:function(){F.verbose("Refreshing selector cache"),y=C.find(g.text),A=C.find(g.search),k=C.find(g.input),L=C.find(g.icon),I=0<C.prev().find(g.text).length?C.prev().find(g.text):C.prev(),D=C.children(g.menu),R=D.find(g.item)},refreshData:function(){F.verbose("Refreshing cached metadata"),R.removeData(h.text).removeData(h.value)},clearData:function(){F.verbose("Clearing metadata"),R.removeData(h.text).removeData(h.value),C.removeData(h.defaultText).removeData(h.defaultValue).removeData(h.placeholderText)},toggle:function(){F.verbose("Toggling menu visibility"),F.is.active()?F.hide():F.show()},show:function(e){if(e=X.isFunction(e)?e:function(){},!F.can.show()&&F.is.remote()&&(F.debug("No API results retrieved, searching before show"),F.queryRemote(F.get.query(),F.show)),F.can.show()&&!F.is.active()){if(F.debug("Showing wtddforselect"),!F.has.message()||F.has.maxSelections()||F.has.allResultsFiltered()||F.remove.message(),F.is.allFiltered())return!0;!1!==v.onShow.call(E)&&F.animate.show(function(){F.can.click()&&F.bind.intent(),F.has.menuSearch()&&F.focusSearch(),F.set.visible(),e.call(E)})}},hide:function(e){e=X.isFunction(e)?e:function(){},F.is.active()&&!F.is.animatingOutward()&&(F.debug("Hiding wtddforselect"),!1!==v.onHide.call(E)&&F.animate.hide(function(){F.remove.visible(),e.call(E)}))},hideOthers:function(){F.verbose("Finding other wtddforselects to hide"),W.not(C).has(g.menu+"."+f.visible).wtdropdown("hide")},hideMenu:function(){F.verbose("Hiding menu  instantaneously"),F.remove.active(),F.remove.visible(),D.wtanimation("hide")},hideSubMenus:function(){var e=D.children(g.item).find(g.menu);F.verbose("Hiding sub menus",e),e.wtanimation("hide")},bind:{events:function(){N&&F.bind.touchEvents(),F.bind.keyboardEvents(),F.bind.inputEvents(),F.bind.mouseEvents()},touchEvents:function(){F.debug("Touch device detected binding additional touch events"),F.is.searchSelection()||F.is.single()&&C.on("touchstart"+w,F.event.test.toggle),D.on("touchstart"+w,g.item,F.event.item.mouseenter)},keyboardEvents:function(){F.verbose("Binding keyboard events"),C.on("keydown"+w,F.event.keydown),F.has.search()&&C.on(F.get.inputEvent()+w,g.search,F.event.input),F.is.multiple()&&H.on("keydown"+a,F.event.document.keydown)},inputEvents:function(){F.verbose("Binding input change events"),C.on("change"+w,g.input,F.event.change)},mouseEvents:function(){F.verbose("Binding mouse events"),F.is.multiple()&&C.on("click"+w,g.label,F.event.label.click).on("click"+w,g.remove,F.event.remove.click),F.is.searchSelection()?(C.on("mousedown"+w,F.event.mousedown).on("mouseup"+w,F.event.mouseup).on("mousedown"+w,g.menu,F.event.menu.mousedown).on("mouseup"+w,g.menu,F.event.menu.mouseup).on("click"+w,g.icon,F.event.icon.click).on("focus"+w,g.search,F.event.search.focus).on("click"+w,g.search,F.event.search.focus).on("blur"+w,g.search,F.event.search.blur).on("click"+w,g.text,F.event.text.focus),F.is.multiple()&&C.on("click"+w,F.event.click)):("click"==v.on?C.on("click"+w,F.event.test.toggle):"hover"==v.on?C.on("mouseenter"+w,F.delay.show).on("mouseleave"+w,F.delay.hide):C.on(v.on+w,F.toggle),C.on("click"+w,g.icon,F.event.icon.click).on("mousedown"+w,F.event.mousedown).on("mouseup"+w,F.event.mouseup).on("focus"+w,F.event.focus),F.has.menuSearch()?C.on("blur"+w,g.search,F.event.search.blur):C.on("blur"+w,F.event.blur)),D.on("mouseenter"+w,g.item,F.event.item.mouseenter).on("mouseleave"+w,g.item,F.event.item.mouseleave).on("click"+w,g.item,F.event.item.click)},intent:function(){F.verbose("Binding hide intent event to document"),N&&H.on("touchstart"+a,F.event.test.touch).on("touchmove"+a,F.event.test.touch),H.on("click"+a,F.event.test.hide)}},unbind:{intent:function(){F.verbose("Removing hide intent event from document"),N&&H.off("touchstart"+a).off("touchmove"+a),H.off("click"+a)}},filter:function(e){function t(){F.is.multiple()&&F.filterActive(),(e||!e&&0==F.get.activeItem().length)&&F.select.firstUnfiltered(),F.has.allResultsFiltered()?v.onNoResults.call(E,n)?v.allowAdditions?v.hideAdditions&&(F.verbose("User addition with no menu, setting empty style"),F.set.empty(),F.hideMenu()):(F.verbose("All items filtered, showing message",n),F.add.message(c.noResults)):(F.verbose("All items filtered, hiding wtddforselect",n),F.hideMenu()):(F.remove.empty(),F.remove.message()),v.allowAdditions&&F.add.userSuggestion(e),F.is.searchSelection()&&F.can.show()&&F.is.focusedOnSearch()&&F.show()}var n=e!==J?e:F.get.query();v.useLabels&&F.has.maxSelections()||(v.apiSettings?F.can.useAPI()?F.queryRemote(n,function(){v.filterRemoteData&&F.filterItems(n),t()}):F.error(b.noAPI):(F.filterItems(n),t()))},queryRemote:function(e,n){e={errorDuration:!1,cache:"local",throttle:v.throttle,urlData:{query:e},onError:function(){F.add.message(c.serverError),n()},onFailure:function(){F.add.message(c.serverError),n()},onSuccess:function(e){var t=e[l.remoteValues];X.isArray(t)&&0<t.length?(F.remove.message(),F.setup.menu({values:e[l.remoteValues]})):F.add.message(c.noResults),n()}};C.api("get request")||F.setup.api(),e=X.extend(!0,{},e,v.apiSettings),C.api("setting",e).api("query")},filterItems:function(e){var n=e!==J?e:F.get.query(),i=null,e=F.escape.string(n),a=new RegExp("^"+e,"igm");F.has.query()&&(i=[],F.verbose("Searching for matching values",n),R.each(function(){var e,t=X(this);if("both"==v.match||"text"==v.match){if(-1!==(e=String(F.get.choiceText(t,!1))).search(a))return i.push(this),!0;if("exact"===v.fullTextSearch&&F.exactSearch(n,e))return i.push(this),!0;if(!0===v.fullTextSearch&&F.fuzzySearch(n,e))return i.push(this),!0}if("both"==v.match||"value"==v.match)return-1!==(e=String(F.get.choiceValue(t,e))).search(a)||"exact"===v.fullTextSearch&&F.exactSearch(n,e)||!0===v.fullTextSearch&&F.fuzzySearch(n,e)?(i.push(this),!0):void 0})),F.debug("Showing only matched items",n),F.remove.filteredItem(),i&&R.not(i).addClass(f.filtered)},fuzzySearch:function(e,t){var n=t.length,i=e.length;if(e=e.toLowerCase(),t=t.toLowerCase(),n<i)return!1;if(i===n)return e===t;e:for(var a=0,s=0;a<i;a++){for(var o=e.charCodeAt(a);s<n;)if(t.charCodeAt(s++)===o)continue e;return!1}return!0},exactSearch:function(e,t){return e=e.toLowerCase(),-1<(t=t.toLowerCase()).indexOf(e)},filterActive:function(){v.useLabels&&R.filter("."+f.active).addClass(f.filtered)},focusSearch:function(e){F.has.search()&&!F.is.focusedOnSearch()&&(e?(C.off("focus"+w,g.search),A.focus(),C.on("focus"+w,g.search,F.event.search.focus)):A.focus())},forceSelection:function(){var e=R.not(f.filtered).filter("."+f.selected).eq(0),t=R.not(f.filtered).filter("."+f.active).eq(0),t=0<e.length?e:t;0<t.length&&!F.is.multiple()?(F.debug("Forcing partial selection to selected item",t),F.event.item.click.call(t,{},!0)):(v.allowAdditions&&F.set.selected(F.get.query()),F.remove.searchTerm())},change:{values:function(e){v.allowAdditions||F.clear(),F.debug("Creating wtddforselect with specified values",e),F.setup.menu({values:e}),X.each(e,function(e,t){if(1==t.selected)return F.debug("Setting initial selection to",t.value),F.set.selected(t.value),!0})}},event:{change:function(){V||(F.debug("Input changed, updating selection"),F.set.selected())},focus:function(){v.showOnFocus&&!q&&F.is.hidden()&&!t&&F.show()},blur:function(e){t=G.activeElement===this,q||t||(F.remove.activeLabel(),F.hide())},mousedown:function(){F.is.searchSelection()?i=!0:q=!0},mouseup:function(){F.is.searchSelection()?i=!1:q=!1},click:function(e){X(e.target).is(C)&&(F.is.focusedOnSearch()?F.show():F.focusSearch())},search:{focus:function(){q=!0,F.is.multiple()&&F.remove.activeLabel(),v.showOnFocus&&F.search()},blur:function(e){t=G.activeElement===this,F.is.searchSelection()&&!i&&(O||t||(v.forceSelection&&F.forceSelection(),F.hide())),i=!1}},icon:{click:function(e){L.hasClass(f.clear)?F.clear():F.can.click()&&F.toggle()}},text:{focus:function(e){q=!0,F.focusSearch()}},input:function(e){(F.is.multiple()||F.is.searchSelection())&&F.set.filtered(),clearTimeout(F.timer),F.timer=setTimeout(F.search,v.delay.search)},label:{click:function(e){var t=X(this),n=C.find(g.label),i=n.filter("."+f.active),a=t.nextAll("."+f.active),s=t.prevAll("."+f.active),s=(0<a.length?t.nextUntil(a):t.prevUntil(s)).add(i).add(t);e.shiftKey?(i.removeClass(f.active),s.addClass(f.active)):e.ctrlKey?t.toggleClass(f.active):(i.removeClass(f.active),t.addClass(f.active)),v.onLabelSelect.apply(this,n.filter("."+f.active))}},remove:{click:function(){var e=X(this).parent();e.hasClass(f.active)?F.remove.activeLabels():F.remove.activeLabels(e)}},test:{toggle:function(e){var t=F.is.multiple()?F.show:F.toggle;F.is.bubbledLabelClick(e)||F.is.bubbledIconClick(e)||F.determine.eventOnElement(e,t)&&e.preventDefault()},touch:function(e){F.determine.eventOnElement(e,function(){"touchstart"==e.type?F.timer=setTimeout(function(){F.hide()},v.delay.touch):"touchmove"==e.type&&clearTimeout(F.timer)}),e.stopPropagation()},hide:function(e){F.determine.eventInModule(e,F.hide)}},select:{mutation:function(e){F.debug("<select> modified, recreating menu");var n=!1;X.each(e,function(e,t){if(X(t.target).is("select")||X(t.addedNodes).is("select"))return n=!0}),n&&(F.disconnect.selectObserver(),F.refresh(),F.setup.select(),F.set.selected(),F.observe.select())}},menu:{mutation:function(e){var t=e[0],e=t.addedNodes?X(t.addedNodes[0]):X(!1),t=t.removedNodes?X(t.removedNodes[0]):X(!1),e=e.add(t),t=e.is(g.addition)||0<e.closest(g.addition).length,e=e.is(g.message)||0<e.closest(g.message).length;t||e?(F.debug("Updating item selector cache"),F.refreshItems()):(F.debug("Menu modified, updating selector cache"),F.refresh())},mousedown:function(){O=!0},mouseup:function(){O=!1}},item:{mouseenter:function(e){var t=X(e.target),n=X(this),i=n.children(g.menu),a=n.siblings(g.item).children(g.menu),n=0<i.length;0<i.find(t).length||!n||(clearTimeout(F.itemTimer),F.itemTimer=setTimeout(function(){F.verbose("Showing sub-menu",i),X.each(a,function(){F.animate.hide(!1,X(this))}),F.animate.show(!1,i)},v.delay.show),e.preventDefault())},mouseleave:function(e){var t=X(this).children(g.menu);0<t.length&&(clearTimeout(F.itemTimer),F.itemTimer=setTimeout(function(){F.verbose("Hiding sub-menu",t),F.animate.hide(!1,t)},v.delay.hide))},click:function(e,t){var n=X(this),i=X(e?e.target:""),a=n.find(g.menu),s=F.get.choiceText(n),o=F.get.choiceValue(n,s),e=0<a.length,i=0<a.find(i).length;F.has.menuSearch()&&X(G.activeElement).blur(),i||e&&!v.allowCategorySelection||(F.is.searchSelection()&&(v.allowAdditions&&F.remove.userAddition(),F.remove.searchTerm(),F.is.focusedOnSearch()||1==t||F.focusSearch(!0)),v.useLabels||(F.remove.filteredItem(),F.set.scrollPosition(n)),F.determine.selectAction.call(this,s,o))}},document:{keydown:function(e){var t,n,i,a,s,o,r,l,c,u,d=e.which;F.is.inObject(d,m)&&((n=(t=C.find(g.label)).filter("."+f.active)).data(h.value),c=t.index(n),u=t.length,i=0<n.length,a=1<n.length,s=0===c,o=c+1==u,r=F.is.searchSelection(),l=F.is.focusedOnSearch(),c=F.is.focused(),u=l&&0===F.get.caretPosition(),r&&!i&&!l||(d==m.leftArrow?!c&&!u||i?i&&(e.shiftKey?F.verbose("Adding previous label to selection"):(F.verbose("Selecting previous label"),t.removeClass(f.active)),s&&!a?n.addClass(f.active):n.prev(g.siblingLabel).addClass(f.active).end(),e.preventDefault()):(F.verbose("Selecting previous label"),t.last().addClass(f.active)):d==m.rightArrow?(c&&!i&&t.first().addClass(f.active),i&&(e.shiftKey?F.verbose("Adding next label to selection"):(F.verbose("Selecting next label"),t.removeClass(f.active)),o?r?l?t.removeClass(f.active):F.focusSearch():(a?n.next(g.siblingLabel):n).addClass(f.active):n.next(g.siblingLabel).addClass(f.active),e.preventDefault())):d==m.deleteKey||d==m.backspace?i?(F.verbose("Removing active labels"),o&&r&&!l&&F.focusSearch(),n.last().next(g.siblingLabel).addClass(f.active),F.remove.activeLabels(n),e.preventDefault()):u&&!i&&d==m.backspace&&(F.verbose("Removing last label on input backspace"),n=t.last().addClass(f.active),F.remove.activeLabels(n)):n.removeClass(f.active)))}},keydown:function(e){var t=e.which;if(F.is.inObject(t,m)){var n,i=R.not(g.unselectable).filter("."+f.selected).eq(0),a=D.children("."+f.active).eq(0),s=0<i.length?i:a,o=0<s.length?s.siblings(":not(."+f.filtered+")").addBack():D.children(":not(."+f.filtered+")"),r=s.children(g.menu),l=s.closest(g.menu),c=l.hasClass(f.visible)||l.hasClass(f.animating)||0<l.parent(g.menu).length,u=0<r.length,d=0<s.length,i=0<s.not(g.unselectable).length,a=t==m.delimiter&&v.allowAdditions&&F.is.multiple();if(v.allowAdditions&&v.hideAdditions&&(t==m.enter||a)&&i&&(F.verbose("Selecting item from keyboard shortcut",s),F.event.item.click.call(s,e),F.is.searchSelection()&&F.remove.searchTerm()),F.is.visible()){if(t!=m.enter&&!a||(t==m.enter&&d&&u&&!v.allowCategorySelection?(F.verbose("Pressed enter on unselectable category, opening sub menu"),t=m.rightArrow):i&&(F.verbose("Selecting item from keyboard shortcut",s),F.event.item.click.call(s,e),F.is.searchSelection()&&F.remove.searchTerm()),e.preventDefault()),d&&(t==m.leftArrow&&l[0]!==D[0]&&(F.verbose("Left key pressed, closing sub-menu"),F.animate.hide(!1,l),s.removeClass(f.selected),l.closest(g.item).addClass(f.selected),e.preventDefault()),t==m.rightArrow&&u&&(F.verbose("Right key pressed, opening sub-menu"),F.animate.show(!1,r),s.removeClass(f.selected),r.find(g.item).eq(0).addClass(f.selected),e.preventDefault())),t==m.upArrow){if(n=(d&&c?s.prevAll(g.item+":not("+g.unselectable+")"):R).eq(0),o.index(n)<0)return F.verbose("Up key pressed but reached top of current menu"),void e.preventDefault();F.verbose("Up key pressed, changing active item"),s.removeClass(f.selected),n.addClass(f.selected),F.set.scrollPosition(n),v.selectOnKeydown&&F.is.single()&&F.set.selectedItem(n),e.preventDefault()}if(t==m.downArrow){if(0===(n=d&&c?n=s.nextAll(g.item+":not("+g.unselectable+")").eq(0):R.eq(0)).length)return F.verbose("Down key pressed but reached bottom of current menu"),void e.preventDefault();F.verbose("Down key pressed, changing active item"),R.removeClass(f.selected),n.addClass(f.selected),F.set.scrollPosition(n),v.selectOnKeydown&&F.is.single()&&F.set.selectedItem(n),e.preventDefault()}t==m.pageUp&&(F.scrollPage("up"),e.preventDefault()),t==m.pageDown&&(F.scrollPage("down"),e.preventDefault()),t==m.escape&&(F.verbose("Escape key pressed, closing wtddforselect"),F.hide())}else a&&e.preventDefault(),t!=m.downArrow||F.is.visible()||(F.verbose("Down key pressed, showing wtddforselect"),F.show(),e.preventDefault())}else F.has.search()||F.set.selectedLetter(String.fromCharCode(t))}},trigger:{change:function(){var e=G.createEvent("HTMLEvents"),t=k[0];t&&(F.verbose("Triggering native change event"),e.initEvent("change",!0,!1),t.dispatchEvent(e))}},determine:{selectAction:function(e,t){F.verbose("Determining action",v.action),X.isFunction(F.action[v.action])?(F.verbose("Triggering preset action",v.action,e,t),F.action[v.action].call(E,e,t,this)):X.isFunction(v.action)?(F.verbose("Triggering user action",v.action,e,t),v.action.call(E,e,t,this)):F.error(b.action,v.action)},eventInModule:function(e,t){var n=X(e.target),e=0<n.closest(G.documentElement).length,n=0<n.closest(C).length;return t=X.isFunction(t)?t:function(){},e&&!n?(F.verbose("Triggering event",t),t(),!0):(F.verbose("Event occurred in wtddforselect, canceling callback"),!1)},eventOnElement:function(e,t){var n=X(e.target),i=n.closest(g.siblingLabel),e=G.body.contains(e.target),i=0===C.find(i).length,n=0===n.closest(D).length;return t=X.isFunction(t)?t:function(){},e&&i&&n?(F.verbose("Triggering event",t),t(),!0):(F.verbose("Event occurred in wtddforselect menu, canceling callback"),!1)}},action:{nothing:function(){},activate:function(e,t,n){t=t!==J?t:e,F.can.activate(X(n))&&(F.set.selected(t,X(n)),F.is.multiple()&&!F.is.allFiltered()||F.hideAndClear())},select:function(e,t,n){t=t!==J?t:e,F.can.activate(X(n))&&(F.set.value(t,e,X(n)),F.is.multiple()&&!F.is.allFiltered()||F.hideAndClear())},combo:function(e,t,n){t=t!==J?t:e,F.set.selected(t,X(n)),F.hideAndClear()},hide:function(e,t,n){F.set.value(t,e,X(n)),F.hideAndClear()}},get:{id:function(){return s},defaultText:function(){return C.data(h.defaultText)},defaultValue:function(){return C.data(h.defaultValue)},placeholderText:function(){return"auto"!=v.placeholder&&"string"==typeof v.placeholder?v.placeholder:C.data(h.placeholderText)||""},text:function(){return y.text()},query:function(){return X.trim(A.val())},searchWidth:function(e){return e=e!==J?e:A.val(),T.text(e),Math.ceil(T.width()+1)},selectionCount:function(){var e=F.get.values();return F.is.multiple()?X.isArray(e)?e.length:0:""!==F.get.value()?1:0},wtanimation:function(e){return"auto"==v.wtanimation?F.is.upward(e)?"slide up":"slide down":v.wtanimation},userValues:function(){var e=F.get.values();return!!e&&(e=X.isArray(e)?e:[e],X.grep(e,function(e){return!1===F.get.item(e)}))},uniqueArray:function(n){return X.grep(n,function(e,t){return X.inArray(e,n)===t})},caretPosition:function(){var e,t,n=A.get(0);return"selectionStart"in n?n.selectionStart:G.selection?(n.focus(),t=(e=G.selection.createRange()).text.length,e.moveStart("character",-n.value.length),e.text.length-t):void 0},value:function(){var e=0<k.length?k.val():C.data(h.value),t=X.isArray(e)&&1===e.length&&""===e[0];return e===J||t?"":e},values:function(){var e=F.get.value();return""===e?"":!F.has.selectInput()&&F.is.multiple()?"string"==typeof e?e.split(v.delimiter):"":e},remoteValues:function(){var e=F.get.values(),i=!1;return e&&("string"==typeof e&&(e=[e]),X.each(e,function(e,t){var n=F.read.remoteData(t);F.verbose("Restoring value from session data",n,t),n&&((i=i||{})[t]=n)})),i},choiceText:function(e,t){if(t=t!==J?t:v.preserveHTML,e)return 0<e.find(g.menu).length&&(F.verbose("Retrieving text of element with sub-menu"),(e=e.clone()).find(g.menu).remove(),e.find(g.menuIcon).remove()),e.data(h.text)!==J?e.data(h.text):t?X.trim(e.html()):X.trim(e.text())},choiceValue:function(e,t){return t=t||F.get.choiceText(e),!!e&&(e.data(h.value)!==J?String(e.data(h.value)):"string"==typeof t?X.trim(t.toLowerCase()):String(t))},inputEvent:function(){var e=A[0];return!!e&&(e.oninput!==J?"input":e.onpropertychange!==J?"propertychange":"keyup")},selectValues:function(){var i={values:[]};return C.find("option").each(function(){var e=X(this),t=e.html(),n=e.attr("disabled"),e=e.attr("value")!==J?e.attr("value"):t;"auto"===v.placeholder&&""===e?i.placeholder=t:i.values.push({name:t,value:e,disabled:n})}),v.placeholder&&"auto"!==v.placeholder&&(F.debug("Setting placeholder value to",v.placeholder),i.placeholder=v.placeholder),v.sortSelect?(i.values.sort(function(e,t){return e.name>t.name?1:-1}),F.debug("Retrieved and sorted values from select",i)):F.debug("Retrieved values from select",i),i},activeItem:function(){return R.filter("."+f.active)},selectedItem:function(){var e=R.not(g.unselectable).filter("."+f.selected);return 0<e.length?e:R.eq(0)},itemWithAdditions:function(e){var t=F.get.item(e),e=F.create.userChoice(e);return e&&0<e.length&&(t=0<t.length?t.add(e):e),t},item:function(i,a){var s=!1,e=(i=i!==J?i:F.get.values()!==J?F.get.values():F.get.text())!==J&&null!==i,o=F.is.multiple()&&X.isArray(i);return a=""===i||0===i||(a||!1),e&&R.each(function(){var e=X(this),t=F.get.choiceText(e),n=F.get.choiceValue(e,t);if(null!==n&&n!==J)if(o)-1===X.inArray(String(n),i)&&-1===X.inArray(t,i)||(s=s?s.add(e):e);else if(a){if(F.verbose("Ambiguous wtddforselect value using strict type check",e,i),n===i||t===i)return s=e,!0}else if(String(n)==String(i)||t==i)return F.verbose("Found select item by value",n,i),s=e,!0}),s}},check:{maxSelections:function(e){return!v.maxSelections||((e=e!==J?e:F.get.selectionCount())>=v.maxSelections?(F.debug("Maximum selection count reached"),v.useLabels&&(R.addClass(f.filtered),F.add.message(c.maxSelections)),!0):(F.verbose("No longer at maximum selection count"),F.remove.message(),F.remove.filteredItem(),F.is.searchSelection()&&F.filterItems(),!1))}},restore:{defaults:function(){F.clear(),F.restore.defaultText(),F.restore.defaultValue()},defaultText:function(){var e=F.get.defaultText();e===F.get.placeholderText?(F.debug("Restoring default placeholder text",e),F.set.placeholderText(e)):(F.debug("Restoring default text",e),F.set.text(e))},placeholderText:function(){F.set.placeholderText()},defaultValue:function(){var e=F.get.defaultValue();e!==J&&(F.debug("Restoring default value",e),""!==e?(F.set.value(e),F.set.selected()):(F.remove.activeItem(),F.remove.selectedItem()))},labels:function(){v.allowAdditions&&(v.useLabels||(F.error(b.labels),v.useLabels=!0),F.debug("Restoring selected values"),F.create.userLabels()),F.check.maxSelections()},selected:function(){F.restore.values(),F.is.multiple()?(F.debug("Restoring previously selected values and labels"),F.restore.labels()):F.debug("Restoring previously selected values")},values:function(){F.set.initialLoad(),v.apiSettings&&v.saveRemoteData&&F.get.remoteValues()?F.restore.remoteValues():F.set.selected(),F.remove.initialLoad()},remoteValues:function(){var e=F.get.remoteValues();F.debug("Recreating selected from session data",e),e&&(F.is.single()?X.each(e,function(e,t){F.set.text(t)}):X.each(e,function(e,t){F.add.label(e,t)}))}},read:{remoteData:function(e){if(Y.Storage!==J)return(e=sessionStorage.getItem(e))!==J&&e;F.error(b.noStorage)}},save:{defaults:function(){F.save.defaultText(),F.save.placeholderText(),F.save.defaultValue()},defaultValue:function(){var e=F.get.value();F.verbose("Saving default value as",e),C.data(h.defaultValue,e)},defaultText:function(){var e=F.get.text();F.verbose("Saving default text as",e),C.data(h.defaultText,e)},placeholderText:function(){var e;!1!==v.placeholder&&y.hasClass(f.placeholder)&&(e=F.get.text(),F.verbose("Saving placeholder text as",e),C.data(h.placeholderText,e))},remoteData:function(e,t){Y.Storage!==J?(F.verbose("Saving remote data to session storage",t,e),sessionStorage.setItem(t,e)):F.error(b.noStorage)}},clear:function(){F.is.multiple()&&v.useLabels?F.remove.labels():(F.remove.activeItem(),F.remove.selectedItem()),F.set.placeholderText(),F.clearValue()},clearValue:function(){F.set.value("")},scrollPage:function(e,t){var n=t||F.get.selectedItem(),i=n.closest(g.menu),a=i.outerHeight(),s=i.scrollTop(),t=R.eq(0).outerHeight(),a=Math.floor(a/t),s=(i.prop("scrollHeight"),"up"==e?s-t*a:s+t*a),t=R.not(g.unselectable),a="up"==e?t.index(n)-a:t.index(n)+a,t=("up"==e?0<=a:a<t.length)?t.eq(a):"up"==e?t.first():t.last();0<t.length&&(F.debug("Scrolling page",e,t),n.removeClass(f.selected),t.addClass(f.selected),v.selectOnKeydown&&F.is.single()&&F.set.selectedItem(t),i.scrollTop(s))},set:{filtered:function(){var e=F.is.multiple(),t=F.is.searchSelection(),n=e&&t,i=t?F.get.query():"",a="string"==typeof i&&0<i.length,t=F.get.searchWidth(),i=""!==i;e&&a&&(F.verbose("Adjusting input width",t,v.glyphWidth),A.css("width",t)),a||n&&i?(F.verbose("Hiding placeholder text"),y.addClass(f.filtered)):e&&(!n||i)||(F.verbose("Showing placeholder text"),y.removeClass(f.filtered))},empty:function(){C.addClass(f.empty)},loading:function(){C.addClass(f.loading)},placeholderText:function(e){e=e||F.get.placeholderText(),F.debug("Setting placeholder text",e),F.set.text(e),y.addClass(f.placeholder)},tabbable:function(){F.is.searchSelection()?(F.debug("Added tabindex to searchable wtddforselect"),A.val("").attr("tabindex",0),D.attr("tabindex",-1)):(F.debug("Added tabindex to wtddforselect"),C.attr("tabindex")===J&&(C.attr("tabindex",0),D.attr("tabindex",-1)))},initialLoad:function(){F.verbose("Setting initial load"),e=!0},activeItem:function(e){v.allowAdditions&&0<e.filter(g.addition).length?e.addClass(f.filtered):e.addClass(f.active)},partialSearch:function(e){var t=F.get.query().length;A.val(e.substr(0,t))},scrollPosition:function(e,t){var n,i,a=(e=e||F.get.selectedItem()).closest(g.menu),s=e&&0<e.length;t=t!==J&&t,e&&0<a.length&&s&&(e.position().top,a.addClass(f.loading),e=(s=a.scrollTop())-a.offset().top+e.offset().top,t||(i=s+a.height()<e+5,n=e-5<s),F.debug("Scrolling to active item",e),(t||n||i)&&a.scrollTop(e),a.removeClass(f.loading))},text:function(e){"select"!==v.action&&("combo"==v.action?(F.debug("Changing combo button text",e,I),v.preserveHTML?I.html(e):I.text(e)):(e!==F.get.placeholderText()&&y.removeClass(f.placeholder),F.debug("Changing text",e,y),y.removeClass(f.filtered),v.preserveHTML?y.html(e):y.text(e)))},selectedItem:function(e){var t=F.get.choiceValue(e),n=F.get.choiceText(e,!1),i=F.get.choiceText(e,!0);F.debug("Setting user selection to item",e),F.remove.activeItem(),F.set.partialSearch(n),F.set.activeItem(e),F.set.selected(t,e),F.set.text(i)},selectedLetter:function(e){var t=R.filter("."+f.selected),n=0<t.length&&F.has.firstLetter(t,e),i=!1;n&&(n=t.nextAll(R).eq(0),F.has.firstLetter(n,e)&&(i=n)),i||R.each(function(){if(F.has.firstLetter(X(this),e))return i=X(this),!1}),i&&(F.verbose("Scrolling to next value with letter",e),F.set.scrollPosition(i),t.removeClass(f.selected),i.addClass(f.selected),v.selectOnKeydown&&F.is.single()&&F.set.selectedItem(i))},direction:function(e){"auto"==v.direction?(F.remove.upward(),(F.can.openDownward(e)?F.remove:F.set).upward(e),F.is.leftward(e)||F.can.openRightward(e)||F.set.leftward(e)):"upward"==v.direction&&F.set.upward(e)},upward:function(e){(e||C).addClass(f.upward)},leftward:function(e){(e||D).addClass(f.leftward)},value:function(e,t,n){var i=F.escape.value(e),a=0<k.length,s=F.get.values(),o=e!==J?String(e):e;if(a){if(!v.allowReselection&&o==s&&(F.verbose("Skipping value update already same value",e,s),!F.is.initialLoad()))return;F.is.single()&&F.has.selectInput()&&F.can.extendSelect()&&(F.debug("Adding user option",e),F.add.optionValue(e)),F.debug("Updating input value",i,s),V=!0,k.val(i),!1===v.fireOnInit&&F.is.initialLoad()?F.debug("Input native change event ignored on initial load"):F.trigger.change(),V=!1}else F.verbose("Storing value in metadata",i,k),i!==s&&C.data(h.value,o);F.is.single()&&v.clearable&&(i?F.set:F.remove).clearable(),!1===v.fireOnInit&&F.is.initialLoad()?F.verbose("No callback on initial load",v.onChange):v.onChange.call(E,e,t,n)},active:function(){C.addClass(f.active)},multiple:function(){C.addClass(f.multiple)},visible:function(){C.addClass(f.visible)},exactly:function(e,t){F.debug("Setting selected to exact values"),F.clear(),F.set.selected(e,t)},selected:function(e,r){var l=F.is.multiple();(r=v.allowAdditions?r||F.get.itemWithAdditions(e):r||F.get.item(e))&&(F.debug("Setting selected menu item to",r),F.is.multiple()&&F.remove.searchWidth(),F.is.single()?(F.remove.activeItem(),F.remove.selectedItem()):v.useLabels&&F.remove.selectedItem(),r.each(function(){var e=X(this),t=F.get.choiceText(e),n=F.get.choiceValue(e,t),i=e.hasClass(f.filtered),a=e.hasClass(f.active),s=e.hasClass(f.addition),o=l&&1==r.length;l?!a||s?(v.apiSettings&&v.saveRemoteData&&F.save.remoteData(t,n),v.useLabels?(F.add.label(n,t,o),F.add.value(n,t,e),F.set.activeItem(e),F.filterActive(),F.select.nextAvailable(r)):(F.add.value(n,t,e),F.set.text(F.add.variables(c.count)),F.set.activeItem(e))):i||(F.debug("Selected active value, removing label"),F.remove.selected(n)):(v.apiSettings&&v.saveRemoteData&&F.save.remoteData(t,n),F.set.text(t),F.set.value(n,t,e),e.addClass(f.active).addClass(f.selected))}))},clearable:function(){L.addClass(f.clear)}},add:{label:function(e,t,n){var i,a=F.is.searchSelection()?A:y,s=F.escape.value(e);v.ignoreCase&&(s=s.toLowerCase()),i=X("<a />").addClass(f.label).attr("data-"+h.value,s).html(p.label(s,t)),i=v.onLabelCreate.call(i,s,t),F.has.label(e)?F.debug("User selection already exists, skipping",s):(v.label.variation&&i.addClass(v.label.variation),!0===n?(F.debug("Animating in label",i),i.addClass(f.hidden).insertBefore(a).wtanimation(v.label.wtanimation,v.label.duration)):(F.debug("Adding selection label",i),i.insertBefore(a)))},message:function(e){var t=D.children(g.message),e=v.templates.message(F.add.variables(e));0<t.length?t.html(e):t=X("<div/>").html(e).addClass(f.message).appendTo(D)},optionValue:function(e){var t=F.escape.value(e);0<k.find('option[value="'+F.escape.string(t)+'"]').length||(F.disconnect.selectObserver(),F.is.single()&&(F.verbose("Removing previous user addition"),k.find("option."+f.addition).remove()),X("<option/>").prop("value",t).addClass(f.addition).html(e).appendTo(k),F.verbose("Adding user addition as an <option>",e),F.observe.select())},userSuggestion:function(e){var t=D.children(g.addition),n=F.get.item(e),i=n&&n.not(g.addition).length,n=0<t.length;v.useLabels&&F.has.maxSelections()||(""===e||i?t.remove():(n?(t.data(h.value,e).data(h.text,e).attr("data-"+h.value,e).attr("data-"+h.text,e).removeClass(f.filtered),v.hideAdditions||(n=v.templates.addition(F.add.variables(c.addResult,e)),t.html(n)),F.verbose("Replacing user suggestion with new value",t)):((t=F.create.userChoice(e)).prependTo(D),F.verbose("Adding item choice to menu corresponding with user choice addition",t)),v.hideAdditions&&!F.is.allFiltered()||t.addClass(f.selected).siblings().removeClass(f.selected),F.refreshItems()))},variables:function(e,t){var n,i=-1!==e.search("{count}"),a=-1!==e.search("{maxCount}"),s=-1!==e.search("{term}");return F.verbose("Adding templated variables to message",e),i&&(n=F.get.selectionCount(),e=e.replace("{count}",n)),a&&(n=F.get.selectionCount(),e=e.replace("{maxCount}",v.maxSelections)),s&&(t=t||F.get.query(),e=e.replace("{term}",t)),e},value:function(e,t,n){var i,a=F.get.values();F.has.value(e)?F.debug("Value already selected"):""!==e?(i=X.isArray(a)?(i=a.concat([e]),F.get.uniqueArray(i)):[e],F.has.selectInput()?F.can.extendSelect()&&(F.debug("Adding value to select",e,i,k),F.add.optionValue(e)):(i=i.join(v.delimiter),F.debug("Setting hidden input to delimited value",i,k)),!1===v.fireOnInit&&F.is.initialLoad()?F.verbose("Skipping onadd callback on initial load",v.onAdd):v.onAdd.call(E,e,t,n),F.set.value(i,e,t,n),F.check.maxSelections()):F.debug("Cannot select blank values from multiselect")}},remove:{active:function(){C.removeClass(f.active)},activeLabel:function(){C.find(g.label).removeClass(f.active)},empty:function(){C.removeClass(f.empty)},loading:function(){C.removeClass(f.loading)},initialLoad:function(){e=!1},upward:function(e){(e||C).removeClass(f.upward)},leftward:function(e){(e||D).removeClass(f.leftward)},visible:function(){C.removeClass(f.visible)},activeItem:function(){R.removeClass(f.active)},filteredItem:function(){v.useLabels&&F.has.maxSelections()||((v.useLabels&&F.is.multiple()?R.not("."+f.active):R).removeClass(f.filtered),F.remove.empty())},optionValue:function(e){var t=F.escape.value(e),e=k.find('option[value="'+F.escape.string(t)+'"]');0<e.length&&e.hasClass(f.addition)&&(o&&(o.disconnect(),F.verbose("Temporarily disconnecting mutation observer")),e.remove(),F.verbose("Removing user addition as an <option>",t),o&&o.observe(k[0],{childList:!0,subtree:!0}))},message:function(){D.children(g.message).remove()},searchWidth:function(){A.css("width","")},searchTerm:function(){F.verbose("Cleared search term"),A.val(""),F.set.filtered()},userAddition:function(){R.filter(g.addition).remove()},selected:function(e,t){if(!(t=v.allowAdditions?t||F.get.itemWithAdditions(e):t||F.get.item(e)))return!1;t.each(function(){var e=X(this),t=F.get.choiceText(e),n=F.get.choiceValue(e,t);F.is.multiple()?v.useLabels?(F.remove.value(n,t,e),F.remove.label(n)):(F.remove.value(n,t,e),0===F.get.selectionCount()?F.set.placeholderText():F.set.text(F.add.variables(c.count))):F.remove.value(n,t,e),e.removeClass(f.filtered).removeClass(f.active),v.useLabels&&e.removeClass(f.selected)})},selectedItem:function(){R.removeClass(f.selected)},value:function(e,t,n){var i,a=F.get.values();F.has.selectInput()?(F.verbose("Input is <select> removing selected option",e),i=F.remove.arrayValue(e,a),F.remove.optionValue(e)):(F.verbose("Removing from delimited values",e),i=(i=F.remove.arrayValue(e,a)).join(v.delimiter)),!1===v.fireOnInit&&F.is.initialLoad()?F.verbose("No callback on initial load",v.onRemove):v.onRemove.call(E,e,t,n),F.set.value(i,t,n),F.check.maxSelections()},arrayValue:function(t,e){return X.isArray(e)||(e=[e]),e=X.grep(e,function(e){return t!=e}),F.verbose("Removed value from delimited string",t,e),e},label:function(e,t){e=C.find(g.label).filter("[data-"+h.value+'="'+F.escape.string(e)+'"]');F.verbose("Removing label",e),e.remove()},activeLabels:function(e){e=e||C.find(g.label).filter("."+f.active),F.verbose("Removing active label selections",e),F.remove.labels(e)},labels:function(e){e=e||C.find(g.label),F.verbose("Removing labels",e),e.each(function(){var e=X(this),t=e.data(h.value),n=t!==J?String(t):t,i=F.is.userValue(n);!1!==v.onLabelRemove.call(e,t)?(F.remove.message(),i?(F.remove.value(n),F.remove.label(n)):F.remove.selected(n)):F.debug("Label remove callback cancelled removal")})},tabbable:function(){F.is.searchSelection()?(F.debug("Searchable wtddforselect initialized"),A.removeAttr("tabindex")):(F.debug("Simple selection wtddforselect initialized"),C.removeAttr("tabindex")),D.removeAttr("tabindex")},clearable:function(){L.removeClass(f.clear)}},has:{menuSearch:function(){return F.has.search()&&0<A.closest(D).length},search:function(){return 0<A.length},sizer:function(){return 0<T.length},selectInput:function(){return k.is("select")},minCharacters:function(e){return!v.minCharacters||(e=e!==J?String(e):String(F.get.query())).length>=v.minCharacters},firstLetter:function(e,t){return!(!e||0===e.length||"string"!=typeof t)&&(e=F.get.choiceText(e,!1),(t=t.toLowerCase())==String(e).charAt(0).toLowerCase())},input:function(){return 0<k.length},items:function(){return 0<R.length},menu:function(){return 0<D.length},message:function(){return 0!==D.children(g.message).length},label:function(e){var t=F.escape.value(e),e=C.find(g.label);return v.ignoreCase&&(t=t.toLowerCase()),0<e.filter("[data-"+h.value+'="'+F.escape.string(t)+'"]').length},maxSelections:function(){return v.maxSelections&&F.get.selectionCount()>=v.maxSelections},allResultsFiltered:function(){var e=R.not(g.addition);return e.filter(g.unselectable).length===e.length},userSuggestion:function(){return 0<D.children(g.addition).length},query:function(){return""!==F.get.query()},value:function(e){return v.ignoreCase?F.has.valueIgnoringCase(e):F.has.valueMatchingCase(e)},valueMatchingCase:function(e){var t=F.get.values();return!!(X.isArray(t)?t&&-1!==X.inArray(e,t):t==e)},valueIgnoringCase:function(n){var e=F.get.values(),i=!1;return X.isArray(e)||(e=[e]),X.each(e,function(e,t){if(String(n).toLowerCase()==String(t).toLowerCase())return!(i=!0)}),i}},is:{active:function(){return C.hasClass(f.active)},animatingInward:function(){return D.wtanimation("is inward")},animatingOutward:function(){return D.wtanimation("is outward")},bubbledLabelClick:function(e){return X(e.target).is("select, input")&&0<C.closest("label").length},bubbledIconClick:function(e){return 0<X(e.target).closest(L).length},alreadySetup:function(){return C.is("select")&&C.parent(g.wtdropdown).data(x)!==J&&0===C.prev().length},animating:function(e){return e?e.wtanimation&&e.wtanimation("is animating"):D.wtanimation&&D.wtanimation("is animating")},leftward:function(e){return(e||D).hasClass(f.leftward)},disabled:function(){return C.hasClass(f.disabled)},focused:function(){return G.activeElement===C[0]},focusedOnSearch:function(){return G.activeElement===A[0]},allFiltered:function(){return(F.is.multiple()||F.has.search())&&!(0==v.hideAdditions&&F.has.userSuggestion())&&!F.has.message()&&F.has.allResultsFiltered()},hidden:function(e){return!F.is.visible(e)},initialLoad:function(){return e},inObject:function(n,e){var i=!1;return X.each(e,function(e,t){if(t==n)return i=!0}),i},multiple:function(){return C.hasClass(f.multiple)},remote:function(){return v.apiSettings&&F.can.useAPI()},single:function(){return!F.is.multiple()},selectMutation:function(e){var n=!1;return X.each(e,function(e,t){if(t.target&&X(t.target).is("select"))return n=!0}),n},search:function(){return C.hasClass(f.search)},searchSelection:function(){return F.has.search()&&1===A.parent(g.wtdropdown).length},selection:function(){return C.hasClass(f.selection)},userValue:function(e){return-1!==X.inArray(e,F.get.userValues())},upward:function(e){return(e||C).hasClass(f.upward)},visible:function(e){return(e||D).hasClass(f.visible)},verticallyScrollableContext:function(){var e=S.get(0)!==Y&&S.css("overflow-y");return"auto"==e||"scroll"==e},horizontallyScrollableContext:function(){var e=S.get(0)!==Y&&S.css("overflow-X");return"auto"==e||"scroll"==e}},can:{activate:function(e){return!!v.useLabels||(!F.has.maxSelections()||!(!F.has.maxSelections()||!e.hasClass(f.active)))},openDownward:function(e){var t,n=e||D,i=!0;return n.addClass(f.loading),e={context:{offset:S.get(0)===Y?{top:0,left:0}:S.offset(),scrollTop:S.scrollTop(),height:S.outerHeight()},menu:{offset:n.offset(),height:n.outerHeight()}},F.is.verticallyScrollableContext()&&(e.menu.offset.top+=e.context.scrollTop),i=(t={above:e.context.scrollTop<=e.menu.offset.top-e.context.offset.top-e.menu.height,below:e.context.scrollTop+e.context.height>=e.menu.offset.top-e.context.offset.top+e.menu.height}).below?(F.verbose("Wtddforselect can fit in context downward",t),!0):t.below||t.above?(F.verbose("Wtddforselect cannot fit below, opening upward",t),!1):(F.verbose("Wtddforselect cannot fit in either direction, favoring downward",t),!0),n.removeClass(f.loading),i},openRightward:function(e){var t,n=e||D,i=!0;return n.addClass(f.loading),e={context:{offset:S.get(0)===Y?{top:0,left:0}:S.offset(),scrollLeft:S.scrollLeft(),width:S.outerWidth()},menu:{offset:n.offset(),width:n.outerWidth()}},F.is.horizontallyScrollableContext()&&(e.menu.offset.left+=e.context.scrollLeft),(t=e.menu.offset.left-e.context.offset.left+e.menu.width>=e.context.scrollLeft+e.context.width)&&(F.verbose("Wtddforselect cannot fit in context rightward",t),i=!1),n.removeClass(f.loading),i},click:function(){return N||"click"==v.on},extendSelect:function(){return v.allowAdditions||v.apiSettings},show:function(){return!F.is.disabled()&&(F.has.items()||F.has.message())},useAPI:function(){return X.fn.api!==J}},animate:{show:function(e,t){var n=t||D,i=t?function(){}:function(){F.hideSubMenus(),F.hideOthers(),F.set.active()};e=X.isFunction(e)?e:function(){},F.verbose("Doing menu show animation",n),F.set.direction(t),t=F.get.wtanimation(t),F.is.selection()&&F.set.scrollPosition(F.get.selectedItem(),!0),(F.is.hidden(n)||F.is.animating(n))&&("none"==t?(i(),n.wtanimation("show"),e.call(E)):X.fn.wtanimation!==J&&C.wtanimation("is supported")?n.wtanimation({animation:t+" in",debug:v.debug,verbose:v.verbose,duration:v.duration,queue:!0,onStart:i,onComplete:function(){e.call(E)}}):F.error(b.noWtanimation,t))},hide:function(e,t){var n=t||D,i=(t?v.duration:v.duration,t?function(){}:function(){F.can.click()&&F.unbind.intent(),F.remove.active()}),t=F.get.wtanimation(t);e=X.isFunction(e)?e:function(){},(F.is.visible(n)||F.is.animating(n))&&(F.verbose("Doing menu hide animation",n),"none"==t?(i(),n.wtanimation("hide"),e.call(E)):X.fn.wtanimation!==J&&C.wtanimation("is supported")?n.wtanimation({animation:t+" out",duration:v.duration,debug:v.debug,verbose:v.verbose,queue:!1,onStart:i,onComplete:function(){e.call(E)}}):F.error(b.wtanimation))}},hideAndClear:function(){F.remove.searchTerm(),F.has.maxSelections()||(F.has.search()?F.hide(function(){F.remove.filteredItem()}):F.hide())},delay:{show:function(){F.verbose("Delaying show event to ensure user intent"),clearTimeout(F.timer),F.timer=setTimeout(F.show,v.delay.show)},hide:function(){F.verbose("Delaying hide event to ensure user intent"),clearTimeout(F.timer),F.timer=setTimeout(F.hide,v.delay.hide)}},escape:{value:function(e){var t=X.isArray(e),n="string"==typeof e,i=!n&&!t,n=n&&-1!==e.search(d.quote),a=[];return i||!n?e:(F.debug("Encoding quote values for use in select",e),t?(X.each(e,function(e,t){a.push(t.replace(d.quote,"&quot;"))}),a):e.replace(d.quote,"&quot;"))},string:function(e){return(e=String(e)).replace(d.escape,"\\$&")}},setting:function(e,t){if(F.debug("Changing setting",e,t),X.isPlainObject(e))X.extend(!0,v,e);else{if(t===J)return v[e];X.isPlainObject(v[e])?X.extend(!0,v[e],t):v[e]=t}},internal:function(e,t){if(X.isPlainObject(e))X.extend(!0,F,e);else{if(t===J)return F[e];F[e]=t}},debug:function(){!v.silent&&v.debug&&(v.performance?F.performance.log(arguments):(F.debug=Function.prototype.bind.call(console.info,console,v.name+":"),F.debug.apply(console,arguments)))},verbose:function(){!v.silent&&v.verbose&&v.debug&&(v.performance?F.performance.log(arguments):(F.verbose=Function.prototype.bind.call(console.info,console,v.name+":"),F.verbose.apply(console,arguments)))},error:function(){v.silent||(F.error=Function.prototype.bind.call(console.error,console,v.name+":"),F.error.apply(console,arguments))},performance:{log:function(e){var t,n;v.performance&&(n=(t=(new Date).getTime())-(U||t),U=t,K.push({Name:e[0],Arguments:[].slice.call(e,1)||"",Element:E,"Execution Time":n})),clearTimeout(F.performance.timer),F.performance.timer=setTimeout(F.performance.display,500)},display:function(){var e=v.name+":",n=0;U=!1,clearTimeout(F.performance.timer),X.each(K,function(e,t){n+=t["Execution Time"]}),e+=" "+n+"ms",j&&(e+=" '"+j+"'"),(console.group!==J||console.table!==J)&&0<K.length&&(console.groupCollapsed(e),console.table?console.table(K):X.each(K,function(e,t){console.log(t.Name+": "+t["Execution Time"]+"ms")}),console.groupEnd()),K=[]}},invoke:function(i,e,t){var a,s,n,o=M;return e=e||Q,t=E||t,"string"==typeof i&&o!==J&&(i=i.split(/[\. ]/),a=i.length-1,X.each(i,function(e,t){var n=e!=a?t+i[e+1].charAt(0).toUpperCase()+i[e+1].slice(1):i;if(X.isPlainObject(o[n])&&e!=a)o=o[n];else{if(o[n]!==J)return s=o[n],!1;{if(!X.isPlainObject(o[t])||e==a)return o[t]!==J?s=o[t]:F.error(b.method,i),!1;o=o[t]}}})),X.isFunction(s)?n=s.apply(t,e):s!==J&&(n=s),X.isArray(P)?P.push(n):P!==J?P=[P,n]:n!==J&&(P=n),s}};$?(M===J&&F.initialize(),F.invoke(B)):(M!==J&&M.invoke("destroy"),F.initialize())}),P!==J?P:W},X.fn.wtdropdown.settings={silent:!1,debug:!1,verbose:!1,performance:!0,on:"click",action:"activate",values:!1,clearable:!1,apiSettings:!1,selectOnKeydown:!0,minCharacters:0,filterRemoteData:!1,saveRemoteData:!0,throttle:200,context:Y,direction:"auto",keepOnScreen:!0,match:"both",fullTextSearch:!1,placeholder:"auto",preserveHTML:!0,sortSelect:!1,forceSelection:!0,allowAdditions:!1,ignoreCase:!1,hideAdditions:!0,maxSelections:!1,useLabels:!0,delimiter:",",showOnFocus:!0,allowReselection:!1,allowTab:!0,allowCategorySelection:!1,fireOnInit:!1,wtanimation:"auto",duration:200,glyphWidth:1.037,label:{wtanimation:"scale",duration:200,variation:!1},delay:{hide:300,show:200,search:20,touch:50},onChange:function(e,t,n){},onAdd:function(e,t,n){},onRemove:function(e,t,n){},onLabelSelect:function(e){},onLabelCreate:function(e,t){return X(this)},onLabelRemove:function(e){return!0},onNoResults:function(e){return!0},onShow:function(){},onHide:function(){},name:"Wtdropdown",namespace:"wtdropdown",message:{addResult:"Add <b>{term}</b>",count:"{count} selected",maxSelections:"Max {maxCount} selections",noResults:"No results found.",serverError:"There was an error contacting the server"},error:{action:"You called a wtddforselect action that was not defined",alreadySetup:"Once a select has been initialized behaviors must be called on the created ui wtddforselect",labels:"Allowing user additions currently requires the use of labels.",missingMultiple:"<select> requires multiple property to be set to correctly preserve multiple values",method:"The method you called is not defined.",noAPI:"The API module is required to load resources remotely",noStorage:"Saving remote data requires session storage",noWtanimation:"This module requires ui wtanimations"},regExp:{escape:/[-[\]{}()*+?.,\\^$|#\s]/g,quote:/"/g},metadata:{defaultText:"defaultText",defaultValue:"defaultValue",placeholderText:"placeholder",text:"text",value:"value"},fields:{remoteValues:"results",values:"values",disabled:"disabled",name:"name",value:"value",text:"text"},keys:{backspace:8,delimiter:188,deleteKey:46,enter:13,escape:27,pageUp:33,pageDown:34,leftArrow:37,upArrow:38,rightArrow:39,downArrow:40},selector:{addition:".addition",wtdropdown:".wtdropdown",hidden:".hidden",icon:"> .wtdropdown-icon",input:'> input[type="hidden"], > select',item:".item",label:"> .label",remove:"> .label > .wtdropdown-delete",siblingLabel:".label",menu:".menu",message:".message",menuIcon:".wtdropdown.icon",search:"input.search, .menu > .search > input, .menu input.search",sizer:"> input.sizer",text:"> .text:not(.icon)",unselectable:".disabled, .filtered"},className:{active:"active",addition:"addition",animating:"animating",clear:"clear",disabled:"disabled",empty:"empty",wtdropdown:"wtdropdown",filtered:"filtered",hidden:"hidden wtanimation",item:"item",label:"label",loading:"loading",menu:"menu",message:"message",multiple:"multiple",placeholder:"default",sizer:"sizer",search:"search",selected:"selected",selection:"selection",upward:"upward",leftward:"left",visible:"visible"}},X.fn.wtdropdown.settings.templates={wtdropdown:function(e){var t=e.placeholder||!1,n=(e.values,"");return n+='<i class="wtdropdown-icon"></i>',e.placeholder?n+='<div class="default text">'+t+"</div>":n+='<div class="text"></div>',n+='<div class="menu">',X.each(e.values,function(e,t){n+=t.disabled?'<div class="disabled item" data-value="'+t.value+'">'+t.name+"</div>":'<div class="item" data-value="'+t.value+'">'+t.name+"</div>"}),n+="</div>"},menu:function(e,a){var e=e[a.values]||{},s="";return X.each(e,function(e,t){var n=t[a.text]?'data-text="'+t[a.text]+'"':"",i=t[a.disabled]?"disabled ":"";s+='<div class="'+i+'item" data-value="'+t[a.value]+'"'+n+">",s+=t[a.name],s+="</div>"}),s},label:function(e,t){var wtstr = t.replace(/\&nbsp;&nbsp;/g,'');  return wtstr+'<i class="wtdropdown-delete"></i>'},message:function(e){return e},addition:function(e){return e}}}(jQuery,window,document);

/*!
 * Datepicker v1.0.10
 * https://fengyuanchen.github.io/datepicker
 *
 * Copyright 2014-present Chen Fengyuan
 * Released under the MIT license
 *
 * Date: 2020-09-29T14:46:10.983Z
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(require("jquery")):"function"==typeof define&&define.amd?define(["jquery"],e):e((t="undefined"!=typeof globalThis?globalThis:t||self).jQuery)}(this,function(k){"use strict";function s(t,e){for(var i=0;i<e.length;i++){var a=e[i];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(t,a.key,a)}}k=k&&k.hasOwnProperty("default")?k.default:k;var n={autoShow:!1,autoHide:!1,autoPick:!1,inline:!1,container:null,trigger:null,language:"",format:"mm/dd/yyyy",date:null,startDate:null,endDate:null,startView:0,weekStart:0,yearFirst:!1,yearSuffix:"",days:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],daysShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],daysMin:["Su","Mo","Tu","We","Th","Fr","Sa"],months:["January","February","March","April","May","June","July","August","September","October","November","December"],monthsShort:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],itemTag:"li",mutedClass:"muted",pickedClass:"picked",disabledClass:"disabled",highlightedClass:"highlighted",template:'<div class="datepicker-container"><div class="datepicker-panel" data-view="years picker"><ul><li data-view="years prev">&lsaquo;</li><li data-view="years current"></li><li data-view="years next">&rsaquo;</li></ul><ul data-view="years"></ul></div><div class="datepicker-panel" data-view="months picker"><ul><li data-view="year prev">&lsaquo;</li><li data-view="year current"></li><li data-view="year next">&rsaquo;</li></ul><ul data-view="months"></ul></div><div class="datepicker-panel" data-view="days picker"><ul><li data-view="month prev">&lsaquo;</li><li data-view="month current"></li><li data-view="month next">&rsaquo;</li></ul><ul data-view="week"></ul><ul data-view="days"></ul></div></div>',offset:10,zIndex:1e3,filter:null,show:null,hide:null,pick:null},t="undefined"!=typeof window,e=t?window:{},i=t&&"ontouchstart"in e.document.documentElement,l="datepicker",r="click.".concat(l),h="focus.".concat(l),o="hide.".concat(l),c="keyup.".concat(l),d="pick.".concat(l),a="resize.".concat(l),u="scroll.".concat(l),p="show.".concat(l),f="touchstart.".concat(l),g="".concat(l,"-hide"),y={},m=0,v=1,w=2,D=Object.prototype.toString;function b(t){return"string"==typeof t}var C=Number.isNaN||e.isNaN;function $(t){return"number"==typeof t&&!C(t)}function x(t){return void 0===t}function F(t){return"date"===(e=t,D.call(e).slice(8,-1).toLowerCase())&&!C(t.getTime());var e}function M(a,s){for(var t=arguments.length,n=new Array(2<t?t-2:0),e=2;e<t;e++)n[e-2]=arguments[e];return function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];return a.apply(s,n.concat(e))}}function Y(t){return'[data-view="'.concat(t,'"]')}function O(t,e){return[31,(t=t)%4==0&&t%100!=0||t%400==0?29:28,31,30,31,30,31,31,30,31,30,31][e]}function V(t,e,i){return Math.min(i,O(t,e))}var T=/(y|m|d)+/g;function I(t,e){var i=1<arguments.length&&void 0!==e?e:1,e=String(Math.abs(t)),a=e.length,s="";for(t<0&&(s+="-");a<i;)a+=1,s+="0";return s+e}var S,P=/\d+/g,N={show:function(){this.built||this.build(),this.shown||this.trigger(p).isDefaultPrevented()||(this.shown=!0,this.$picker.removeClass(g).on(r,k.proxy(this.click,this)),this.showView(this.options.startView),this.inline||(this.$scrollParent.on(u,k.proxy(this.place,this)),k(window).on(a,this.onResize=M(this.place,this)),k(document).on(r,this.onGlobalClick=M(this.globalClick,this)),k(document).on(c,this.onGlobalKeyup=M(this.globalKeyup,this)),i&&k(document).on(f,this.onTouchStart=M(this.touchstart,this)),this.place()))},hide:function(){this.shown&&(this.trigger(o).isDefaultPrevented()||(this.shown=!1,this.$picker.addClass(g).off(r,this.click),this.inline||(this.$scrollParent.off(u,this.place),k(window).off(a,this.onResize),k(document).off(r,this.onGlobalClick),k(document).off(c,this.onGlobalKeyup),i&&k(document).off(f,this.onTouchStart))))},toggle:function(){this.shown?this.hide():this.show()},update:function(){var t=this.getValue();t!==this.oldValue&&(this.setDate(t,!0),this.oldValue=t)},pick:function(t){var e=this.$element,i=this.date;this.trigger(d,{view:t||"",date:i}).isDefaultPrevented()||(i=this.formatDate(this.date),this.setValue(i),this.isInput&&(e.trigger("input"),e.trigger("change")))},reset:function(){this.setDate(this.initialDate,!0),this.setValue(this.initialValue),this.shown&&this.showView(this.options.startView)},getMonthName:function(t,e){var i=this.options,a=i.monthsShort,i=i.months;return k.isNumeric(t)?t=Number(t):x(e)&&(e=t),!0===e&&(i=a),i[$(t)?t:this.date.getMonth()]},getDayName:function(t,e,i){var a=this.options,s=a.days;return k.isNumeric(t)?t=Number(t):(x(i)&&(i=e),x(e)&&(e=t)),i?s=a.daysMin:e&&(s=a.daysShort),s[$(t)?t:this.date.getDay()]},getDate:function(t){var e=this.date;return t?this.formatDate(e):new Date(e)},setDate:function(t,e){var i=this.options.filter;if(F(t)||b(t)){if(t=this.parseDate(t),k.isFunction(i)&&!1===i.call(this.$element,t,"day"))return;this.date=t,this.viewDate=new Date(t),e||this.pick(),this.built&&this.render()}},setStartDate:function(t){F(t)||b(t)?this.startDate=this.parseDate(t):this.startDate=null,this.built&&this.render()},setEndDate:function(t){F(t)||b(t)?this.endDate=this.parseDate(t):this.endDate=null,this.built&&this.render()},parseDate:function(a){var s=this.format,t=[];return F(a)||(b(a)&&(t=a.match(P)||[]),F(a=a?new Date(a):new Date)||(a=new Date),t.length===s.parts.length&&(k.each(t,function(t,e){var i=parseInt(e,10);switch(s.parts[t]){case"yy":a.setFullYear(2e3+i);break;case"yyyy":a.setFullYear(2===e.length?2e3+i:i);break;case"mm":case"m":a.setMonth(i-1)}}),k.each(t,function(t,e){e=parseInt(e,10);switch(s.parts[t]){case"dd":case"d":a.setDate(e)}}))),new Date(a.getFullYear(),a.getMonth(),a.getDate())},formatDate:function(t){var e,i,a,s=this.format,n="";return F(t)&&(e=t.getFullYear(),i=t.getMonth(),t=t.getDate(),a={d:t,dd:I(t,2),m:i+1,mm:I(i+1,2),yy:String(e).substring(2),yyyy:I(e,4)},n=s.source,k.each(s.parts,function(t,e){n=n.replace(e,a[e])})),n},destroy:function(){this.unbind(),this.unbuild(),this.$element.removeData(l)}},j={click:function(t){var e=k(t.target),i=this.options,a=this.date,s=this.viewDate,n=this.format;if(t.stopPropagation(),t.preventDefault(),!e.hasClass("disabled")){var r=e.data("view"),h=s.getFullYear(),o=s.getMonth(),t=s.getDate();switch(r){case"years prev":case"years next":h="years prev"===r?h-10:h+10,s.setFullYear(h),s.setDate(V(h,o,t)),this.renderYears();break;case"year prev":case"year next":h="year prev"===r?h-1:h+1,s.setFullYear(h),s.setDate(V(h,o,t)),this.renderMonths();break;case"year current":n.hasYear&&this.showView(w);break;case"year picked":n.hasMonth?this.showView(v):(e.siblings(".".concat(i.pickedClass)).removeClass(i.pickedClass).data("view","year"),this.hideView()),this.pick("year");break;case"year":h=parseInt(e.text(),10),a.setDate(V(h,o,t)),a.setFullYear(h),s.setDate(V(h,o,t)),s.setFullYear(h),n.hasMonth?this.showView(v):(e.addClass(i.pickedClass).data("view","year picked").siblings(".".concat(i.pickedClass)).removeClass(i.pickedClass).data("view","year"),this.hideView()),this.pick("year");break;case"month prev":case"month next":(o="month prev"===r?o-1:o+1)<0?(--h,o+=12):11<o&&(h+=1,o-=12),s.setFullYear(h),s.setDate(V(h,o,t)),s.setMonth(o),this.renderDays();break;case"month current":n.hasMonth&&this.showView(v);break;case"month picked":n.hasDay?this.showView(m):(e.siblings(".".concat(i.pickedClass)).removeClass(i.pickedClass).data("view","month"),this.hideView()),this.pick("month");break;case"month":o=k.inArray(e.text(),i.monthsShort),a.setFullYear(h),a.setDate(V(h,o,t)),a.setMonth(o),s.setFullYear(h),s.setDate(V(h,o,t)),s.setMonth(o),n.hasDay?this.showView(m):(e.addClass(i.pickedClass).data("view","month picked").siblings(".".concat(i.pickedClass)).removeClass(i.pickedClass).data("view","month"),this.hideView()),this.pick("month");break;case"day prev":case"day next":case"day":"day prev"===r?--o:"day next"===r&&(o+=1),t=parseInt(e.text(),10),a.setDate(1),a.setFullYear(h),a.setMonth(o),a.setDate(t),s.setDate(1),s.setFullYear(h),s.setMonth(o),s.setDate(t),this.renderDays(),"day"===r&&this.hideView(),this.pick("day");break;case"day picked":this.hideView(),this.pick("day")}}},globalClick:function(t){for(var e=t.target,i=this.element,a=this.$trigger[0],s=!0;e!==document;){if(e===a||e===i){s=!1;break}e=e.parentNode}s&&this.hide()},keyup:function(){this.update()},globalKeyup:function(t){var e=t.target,i=t.key,t=t.keyCode;this.isInput&&e!==this.element&&this.shown&&("Tab"===i||9===t)&&this.hide()},touchstart:function(t){t=t.target;this.isInput&&t!==this.element&&!k.contains(this.$picker[0],t)&&(this.hide(),this.element.blur())}},q={render:function(){this.renderYears(),this.renderMonths(),this.renderDays()},renderWeek:function(){var i=this,a=[],t=this.options,e=t.weekStart,t=t.daysMin,e=parseInt(e,10)%7,t=t.slice(e).concat(t.slice(0,e));k.each(t,function(t,e){a.push(i.createItem({text:e}))}),this.$week.html(a.join(""))},renderYears:function(){for(var t=this.options,e=this.startDate,i=this.endDate,a=t.disabledClass,s=t.filter,t=t.yearSuffix,n=this.viewDate.getFullYear(),r=(new Date).getFullYear(),h=this.date.getFullYear(),o=[],l=!1,c=!1,d=-5;d<=6;d+=1){var u=new Date(n+d,1,1),p=!1;e&&(p=u.getFullYear()<e.getFullYear(),-5===d&&(l=p)),!p&&i&&(p=u.getFullYear()>i.getFullYear(),6===d&&(c=p)),!p&&s&&(p=!1===s.call(this.$element,u,"year"));var f=n+d===h,g=f?"year picked":"year";o.push(this.createItem({picked:f,disabled:p,text:n+d,view:p?"year disabled":g,highlighted:u.getFullYear()===r}))}this.$yearsPrev.toggleClass(a,l),this.$yearsNext.toggleClass(a,c),this.$yearsCurrent.toggleClass(a,!0).html("".concat(n+-5+t," - ").concat(n+6).concat(t)),this.$years.html(o.join(""))},renderMonths:function(){for(var t=this.options,e=this.startDate,i=this.endDate,a=this.viewDate,s=t.disabledClass||"",n=t.monthsShort,r=k.isFunction(t.filter)&&t.filter,h=a.getFullYear(),a=new Date,o=a.getFullYear(),l=a.getMonth(),c=this.date.getFullYear(),d=this.date.getMonth(),u=[],p=!1,f=!1,g=0;g<=11;g+=1){var y=new Date(h,g,1),m=!1;e&&(m=(p=y.getFullYear()===e.getFullYear())&&y.getMonth()<e.getMonth()),!m&&i&&(m=(f=y.getFullYear()===i.getFullYear())&&y.getMonth()>i.getMonth()),!m&&r&&(m=!1===r.call(this.$element,y,"month"));var v=h===c&&g===d,w=v?"month picked":"month";u.push(this.createItem({disabled:m,picked:v,highlighted:h===o&&y.getMonth()===l,index:g,text:n[g],view:m?"month disabled":w}))}this.$yearPrev.toggleClass(s,p),this.$yearNext.toggleClass(s,f),this.$yearCurrent.toggleClass(s,p&&f).html(h+t.yearSuffix||""),this.$months.html(u.join(""))},renderDays:function(){var t,e=this.$element,i=this.options,a=this.startDate,s=this.endDate,n=this.viewDate,r=this.date,h=i.disabledClass,o=i.filter,l=i.months,c=i.weekStart,d=i.yearSuffix,u=n.getFullYear(),p=n.getMonth(),n=new Date,f=n.getFullYear(),g=n.getMonth(),y=n.getDate(),m=r.getFullYear(),v=r.getMonth(),w=r.getDate(),k=[],D=u,b=p,n=!1;0===p?(--D,b=11):--b,t=O(D,b);var C,r=new Date(u,p,1);for((C=r.getDay()-parseInt(c,10)%7)<=0&&(C+=7),a&&(n=r.getTime()<=a.getTime()),P=t-(C-1);P<=t;P+=1){var $=new Date(D,b,P),x=!1;a&&(x=$.getTime()<a.getTime()),!x&&o&&(x=!1===o.call(e,$,"day")),k.push(this.createItem({disabled:x,highlighted:D===f&&b===g&&$.getDate()===y,muted:!0,picked:D===m&&b===v&&P===w,text:P,view:"day prev"}))}var F=[],M=u,Y=p,c=!1;11===p?(M+=1,Y=0):Y+=1,t=O(u,p),C=42-(k.length+t);r=new Date(u,p,t);for(s&&(c=r.getTime()>=s.getTime()),P=1;P<=C;P+=1){var V=new Date(M,Y,P),T=M===m&&Y===v&&P===w,I=!1;s&&(I=V.getTime()>s.getTime()),!I&&o&&(I=!1===o.call(e,V,"day")),F.push(this.createItem({disabled:I,picked:T,highlighted:M===f&&Y===g&&V.getDate()===y,muted:!0,text:P,view:"day next"}))}for(var S=[],P=1;P<=t;P+=1){var N=new Date(u,p,P),j=!1;a&&(j=N.getTime()<a.getTime()),!j&&s&&(j=N.getTime()>s.getTime()),!j&&o&&(j=!1===o.call(e,N,"day"));var q=u===m&&p===v&&P===w,A=q?"day picked":"day";S.push(this.createItem({disabled:j,picked:q,highlighted:u===f&&p===g&&N.getDate()===y,text:P,view:j?"day disabled":A}))}this.$monthPrev.toggleClass(h,n),this.$monthNext.toggleClass(h,c),this.$monthCurrent.toggleClass(h,n&&c).html(i.yearFirst?"".concat(u+d," ").concat(l[p]):"".concat(l[p]," ").concat(u).concat(d)),this.$days.html(k.join("")+S.join("")+F.join(""))}},A="".concat(l,"-top-left"),t="".concat(l,"-top-right"),W="".concat(l,"-bottom-left"),e="".concat(l,"-bottom-right"),z=[A,t,W,e].join(" "),J=function(){function i(t){var e=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{};!function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,i),this.$element=k(t),this.element=t,this.options=k.extend({},n,y[e.language],k.isPlainObject(e)&&e),this.$scrollParent=function(t,e){var i=1<arguments.length&&void 0!==e&&e,a=k(t),s="absolute"===(e=a.css("position")),n=i?/auto|scroll|hidden/:/auto|scroll/,a=a.parents().filter(function(t,e){e=k(e);return(!s||"static"!==e.css("position"))&&n.test(e.css("overflow")+e.css("overflow-y")+e.css("overflow-x"))}).eq(0);return"fixed"!==e&&a.length?a:k(t.ownerDocument||document)}(t,!0),this.built=!1,this.shown=!1,this.isInput=!1,this.inline=!1,this.initialValue="",this.initialDate=null,this.startDate=null,this.endDate=null,this.init()}var t,e,a;return t=i,a=[{key:"setDefaults",value:function(t){t=0<arguments.length&&void 0!==t?t:{};k.extend(n,y[t.language],k.isPlainObject(t)&&t)}}],(e=[{key:"init",value:function(){var t=this.$element,e=this.options,i=e.startDate,a=e.endDate,s=e.date;this.$trigger=k(e.trigger),this.isInput=t.is("input")||t.is("textarea"),this.inline=e.inline&&(e.container||!this.isInput),this.format=function(i){var t=String(i).toLowerCase(),e=t.match(T);if(!e||0===e.length)throw new Error("Invalid date format.");return i={source:t,parts:e},k.each(e,function(t,e){switch(e){case"dd":case"d":i.hasDay=!0;break;case"mm":case"m":i.hasMonth=!0;break;case"yyyy":case"yy":i.hasYear=!0}}),i}(e.format);t=this.getValue();this.initialValue=t,this.oldValue=t,s=this.parseDate(s||t),i&&(i=this.parseDate(i),s.getTime()<i.getTime()&&(s=new Date(i)),this.startDate=i),a&&(a=this.parseDate(a),i&&a.getTime()<i.getTime()&&(a=new Date(i)),s.getTime()>a.getTime()&&(s=new Date(a)),this.endDate=a),this.date=s,this.viewDate=new Date(s),this.initialDate=new Date(this.date),this.bind(),(e.autoShow||this.inline)&&this.show(),e.autoPick&&this.pick()}},{key:"build",value:function(){var t,e,i;this.built||(this.built=!0,t=this.$element,e=this.options,i=k(e.template),this.$picker=i,this.$week=i.find(Y("week")),this.$yearsPicker=i.find(Y("years picker")),this.$yearsPrev=i.find(Y("years prev")),this.$yearsNext=i.find(Y("years next")),this.$yearsCurrent=i.find(Y("years current")),this.$years=i.find(Y("years")),this.$monthsPicker=i.find(Y("months picker")),this.$yearPrev=i.find(Y("year prev")),this.$yearNext=i.find(Y("year next")),this.$yearCurrent=i.find(Y("year current")),this.$months=i.find(Y("months")),this.$daysPicker=i.find(Y("days picker")),this.$monthPrev=i.find(Y("month prev")),this.$monthNext=i.find(Y("month next")),this.$monthCurrent=i.find(Y("month current")),this.$days=i.find(Y("days")),this.inline?k(e.container||t).append(i.addClass("".concat(l,"-inline"))):(k(document.body).append(i.addClass("".concat(l,"-dropdown"))),i.addClass(g).css({zIndex:parseInt(e.zIndex,10)})),this.renderWeek())}},{key:"unbuild",value:function(){this.built&&(this.built=!1,this.$picker.remove())}},{key:"bind",value:function(){var t=this.options,e=this.$element;k.isFunction(t.show)&&e.on(p,t.show),k.isFunction(t.hide)&&e.on(o,t.hide),k.isFunction(t.pick)&&e.on(d,t.pick),this.isInput&&e.on(c,k.proxy(this.keyup,this)),this.inline||(t.trigger?this.$trigger.on(r,k.proxy(this.toggle,this)):this.isInput?e.on(h,k.proxy(this.show,this)):e.on(r,k.proxy(this.show,this)))}},{key:"unbind",value:function(){var t=this.$element,e=this.options;k.isFunction(e.show)&&t.off(p,e.show),k.isFunction(e.hide)&&t.off(o,e.hide),k.isFunction(e.pick)&&t.off(d,e.pick),this.isInput&&t.off(c,this.keyup),this.inline||(e.trigger?this.$trigger.off(r,this.toggle):this.isInput?t.off(h,this.show):t.off(r,this.show))}},{key:"showView",value:function(t){var e=this.$yearsPicker,i=this.$monthsPicker,a=this.$daysPicker,s=this.format;if(s.hasYear||s.hasMonth||s.hasDay)switch(Number(t)){case w:i.addClass(g),a.addClass(g),s.hasYear?(this.renderYears(),e.removeClass(g),this.place()):this.showView(m);break;case v:e.addClass(g),a.addClass(g),s.hasMonth?(this.renderMonths(),i.removeClass(g),this.place()):this.showView(w);break;default:e.addClass(g),i.addClass(g),s.hasDay?(this.renderDays(),a.removeClass(g),this.place()):this.showView(v)}}},{key:"hideView",value:function(){!this.inline&&this.options.autoHide&&this.hide()}},{key:"place",value:function(){var t,e,i,a,s,n,r,h,o,l,c;this.inline||(o=this.$element,c=this.options,t=this.$picker,e=k(document).outerWidth(),i=k(document).outerHeight(),a=o.outerWidth(),s=o.outerHeight(),n=t.width(),r=t.height(),h=(l=o.offset()).left,o=l.top,l=parseFloat(c.offset),c=A,C(l)&&(l=10),r<o&&i<o+s+r?(o-=r+l,c=W):o+=s+l,e<h+n&&(h+=a-n,c=c.replace("left","right")),t.removeClass(z).addClass(c).css({top:o,left:h}))}},{key:"trigger",value:function(t,e){e=k.Event(t,e);return this.$element.trigger(e),e}},{key:"createItem",value:function(t){var e=this.options,i=e.itemTag,a={text:"",view:"",muted:!1,picked:!1,disabled:!1,highlighted:!1},s=[];return k.extend(a,t),a.muted&&s.push(e.mutedClass),a.highlighted&&s.push(e.highlightedClass),a.picked&&s.push(e.pickedClass),a.disabled&&s.push(e.disabledClass),"<".concat(i,' class="').concat(s.join(" "),'" data-view="').concat(a.view,'">').concat(a.text,"</").concat(i,">")}},{key:"getValue",value:function(){var t=this.$element;return this.isInput?t.val():t.text()}},{key:"setValue",value:function(t){var e=0<arguments.length&&void 0!==t?t:"",t=this.$element;this.isInput?t.val(e):this.inline&&!this.options.container||t.text(e)}}])&&s(t.prototype,e),a&&s(t,a),i}();k.extend&&k.extend(J.prototype,q,j,N),k.fn&&(S=k.fn.datepicker,k.fn.datepicker=function(r){for(var h,t=arguments.length,o=new Array(1<t?t-1:0),e=1;e<t;e++)o[e-1]=arguments[e];return this.each(function(t,e){var i=k(e),a="destroy"===r;if(!(n=i.data(l))){if(a)return;var s=k.extend({},i.data(),k.isPlainObject(r)&&r),n=new J(e,s);i.data(l,n)}b(r)&&(s=n[r],k.isFunction(s)&&(h=s.apply(n,o),a&&i.removeData(l)))}),x(h)?this:h},k.fn.datepicker.Constructor=J,k.fn.datepicker.languages=y,k.fn.datepicker.setDefaults=J.setDefaults,k.fn.datepicker.noConflict=function(){return k.fn.datepicker=S,this})});

// Add Agent
(function($){
	$.wpgsAddAgent = function() {
		// Get users to select as agent
        var resultarea = $('div.wpgs-dropdown-search-menu'),
		$text = $('div.wpgs-dropdown-search-text').html(),
		$input = $('input#wpgs_dropdown_search_box'),
		wpgsTypingInterval = 500,
    	wpgsTypingTimer;

		// Change Agent id on click
		$(document).on('click', '.wpgs-dropdown-search-menu > .item', function(event) {
			event.stopPropagation();
			var $this = $(this),
				$selected_id = $this.attr('data-value'),
				$selected_text = $this.html();
			$text = $selected_text;
			$('input#wpgs_dropdown_search_main').val($selected_id);
			$('div.wpgs-dropdown-search-text').html($text);
			$input.val($text);
			resultarea.hide(50);
		});
		$(document).on("click", function() {
			$input.val($text);
			resultarea.hide(50);
		});

		$('input#wpgs_dropdown_search_box').on("click", function(event) {
			event.stopPropagation();
		});

		$input.on('focus', function (event) {
			$input.val('');
			resultarea.show(50);
		});
		$input.on('keyup', function (event) {
			clearTimeout(wpgsTypingTimer);
			wpgsTypingTimer = setTimeout(wpgsDoneTyping, wpgsTypingInterval);
		});
		$input.on('keydown', function () {
			clearTimeout(wpgsTypingTimer);
		});
		function wpgsDoneTyping () {
			resultarea.html('');
			var searchterm = $input.val();
			if (searchterm != '' && searchterm.length > 1) {
				var post_vars = new Array();
				post_vars.push({name:'wpgs_handler', value: 'ajax'});
				post_vars.push({name:'request', value: 'get_users'});
				post_vars.push({name:'searchterm', value: searchterm});
				var data = jQuery.post('', post_vars);

				data.done(function(reply_data) {
					var response_json = jQuery.parseJSON(reply_data);
					resultarea.html(response_json);
				});
			} else {
				resultarea.html('');
			}
		}
    };
})(jQuery);

jQuery(document).ready(function($) {
	// Users selector
	$('select.wpgs-select-dept-agent').wtdropdown();
	$('select#wpgs_suggest_docs_cats').wtdropdown();
	$('select#wpgs_applicable_forms').wtdropdown();

	var wtTab = $('ul#wt-tab-menu li.wt-tab-item');
	var wtTabContent = $('div.wt-tab-content');
	wtTab.click(function() {
		wtTabContent.hide().removeClass("active");
		wtTab.removeClass("active");
		$(this).addClass("active");
		var activeWtTab = $(this).attr("data-wttab");
		$("div#"+activeWtTab).fadeIn();
	});

	// Date picker
	$('[data-toggle="datepicker"]').datepicker({
		format: 'YYYY-MM-DD'
	});

	$(document).on('click', 'ul.wt-tabs-dd-menu li.wt-tabs-dd-item', function(event) {
		var $this = $(this);
		var $thisDiv = $this.closest('div.wt-tabs-dd-wrapper');
		var $thisUl = $this.closest('ul.wt-tabs-dd-menu');
		var $thisText = $thisDiv.find('span.wt-tabs-dd-toggle');
		var $thisAttr = $this.attr("data-wtabsddtab");
		var $allLi = $thisDiv.find('li.wt-tabs-dd-item');

		if (!$this.hasClass('wt-active')) {
			$thisText.html($this.html());
			$allLi.removeClass('wt-active');
			$allLi.css('opacity', '1');
			$this.css('opacity', '0.5');
			$this.addClass('wt-active');
			$thisUl.hide();
			setTimeout(function(){
				$thisUl.show();
			}, 300);
			$('div.wt-tabs-dd-content').hide();
			$('#' + $thisAttr).fadeIn();
		}
	});
	$('input.wt-input-tab-name').keyup(function() {
		var $this = $(this);
		var $thisValue = $this.val();
		var $thisId = $this.attr("id");
		var $liSpan = $( 'ul.wt-tabs-dd-menu li.wt-tabs-dd-item span#' + $thisId );
		var $divSpan = $( 'div.wt-tabs-dd-wrapper span.wt-tabs-dd-toggle > span' );
		$liSpan.html( $thisValue );
		$divSpan.html( $thisValue );

		if ( $thisValue.trim() ) {
			$liSpan.addClass('has-content');
			$divSpan.addClass('has-content');
		} else {
			$liSpan.removeClass('has-content');
			$divSpan.removeClass('has-content');
		}
	});
	$(document).on('click', '#wpgs-delete', function() {
		return confirm("Are you sure? You can't undo this action.");
	});
	// Modals
	$('div.wpgs-modal').appendTo('body');
	$(document).on('click', '#wpgs_open_modal', function() {
		var $this = $(this);
		var $thisContent = $this.attr("data-modal");

		if ( $thisContent == 'wpgs_modal_create_ticket_by_agent' ) {
            $('div#wpgs_create_ticket_by_agent div#wpgs_field_errormsg').hide().html("");
        }

		$('#' + $thisContent).addClass('wpgs-modal-active');
		$('body').addClass('wpgs-modal-active');
	});
	$(document).on('click', '#wpgs_modal_close', function() {
		wpgsModalClose();
		/* $('div.wpgs-modal').removeClass('wpgs-modal-active');
		$('body').removeClass('wpgs-modal-active');
		$('div#wpgs_modal_main_content').html(""); */
	});

	function wpgsModalClose() {
		$('div.wpgs-modal').removeClass('wpgs-modal-active');
		$('body').removeClass('wpgs-modal-active');
		$('div#wpgs_modal_main_content').html("");
	}

	// Add fields
	var $wtPreloader = '<div class="wt-loader"><span></span><span></span><span></span><span></span><span></span></div>';

	// Edit fields
	$(document).on('click', '#wpgs_edit_field', function() {
		var $this = $(this),
			$value = $this.attr("field-type"),
			$editType = $this.attr("field-edit"),
			$thisList = $this.closest('li'),
			$thisListId = $this.closest('li').attr('id'),

			$inputName = $thisList.find('input#wpgs_field_list_name').val(),
			$inputLabel = $thisList.find('input#wpgs_field_list_label').val(),
			$inputPlaceholder = $thisList.find('input#wpgs_field_list_placeholder').val(),
			$inputRequired = $thisList.find('input#wpgs_field_list_required').val(),
			$inputDescription = $thisList.find('textarea#wpgs_field_list_description').val(),
			$inputErrorMessage = $thisList.find('textarea#wpgs_field_list_error_message').val(),
			$inputColsize = $thisList.find('input#wpgs_field_list_colsize').val(),

			$fieldtoform = $thisList.find('input#wpgs_field_list_fieldtoform').val(),
			$showonticketview = $thisList.find('input#wpgs_field_list_showonticketview').val(),
			$addtoemail = $thisList.find('input#wpgs_field_list_addtoemail').val(),
			$login_required = $thisList.find('input#wpgs_field_list_login_required').val(),

			$min = $thisList.find('input#wpgs_field_list_min').val(),
			$max = $thisList.find('input#wpgs_field_list_max').val(),
			$options = $thisList.find('textarea#wpgs_field_list_options').val(),
			$hidden_field_value = $thisList.find('input#wpgs_field_list_hidden_value').val(),
			$custom_field_content = $thisList.find('textarea#wpgs_field_list_customtext').val();

		$thisList.addClass('wpgs_field_updating');

		if ( $value == 'departments' ) {
			var $showonform = $thisList.find('input#wpgs_field_list_showonform').val();
			var $default_department = $thisList.find('input#wpgs_field_list_default_department').val();
		}

		var $content = '<ul id="wpgs_field_type_' + $value + '" class="wpgs-field-contents">' + $('ul#wpgs_field_type_' + $value).html() + '</ul>';

		// Change modal title
		$('span#wpgs_modal_edit_field_title').html( $inputName );

		// Activate modal
		$('#wpgs_modal_edit_fields').addClass('wpgs-modal-active');
		$('body').addClass('wpgs-modal-active');
		$('div#wpgs_modal_main_content').html($wtPreloader);

		setTimeout(function(){
			$('div#wpgs_modal_main_content').html($content);

			// Delete field name option for core field.
			if ( $editType == 'core' ) {
				$('div#wpgs_modal_main_content li.wpgs_field_list_name').remove();
				$('div#wpgs_modal_main_content li.wpgs_field_list_required').remove();
				$('div#wpgs_modal_main_content li.wpgs_field_list_showonticketview').remove();
				$('div#wpgs_modal_main_content li.wpgs_field_list_fieldtoform').remove();
				$('div#wpgs_modal_main_content li.wpgs_field_list_addtoemail').remove();
				$('div#wpgs_modal_main_content li.wpgs_field_list_login_required').remove();
			} else {
				$('div#wpgs_modal_main_content li.wpgs_field_list_name').hide();
			}
			// Change modal inputs
			$('div#wpgs_modal_main_content input#field_name').val( $inputName );
			$('div#wpgs_modal_main_content input#field_label').val( $inputLabel );
			$('div#wpgs_modal_main_content input#field_placeholder').val( $inputPlaceholder );
			$('div#wpgs_modal_main_content select#field_required').val( $inputRequired ).change();
			$('div#wpgs_modal_main_content textarea#field_description').val( $inputDescription );
			$('div#wpgs_modal_main_content textarea#field_error_message').val( $inputErrorMessage );
			$('div#wpgs_modal_main_content select#wpgs_field_list_colsize').val( $inputColsize ).change();

			$('div#wpgs_modal_main_content select#wpgs_field_list_fieldtoform').val( $fieldtoform ).change();
			$('div#wpgs_modal_main_content select#wpgs_field_list_showonticketview').val( $showonticketview ).change();
			$('div#wpgs_modal_main_content select#wpgs_field_list_addtoemail').val( $addtoemail ).change();
			$('div#wpgs_modal_main_content select#wpgs_field_list_login_required').val( $login_required ).change();

			$('div#wpgs_modal_main_content input#field_min').val( $min );
			$('div#wpgs_modal_main_content input#field_max').val( $max );
			$('div#wpgs_modal_main_content textarea#field_options').val( $options );
			$('div#wpgs_modal_main_content input#field_value').val( $hidden_field_value );
			$('div#wpgs_modal_main_content textarea#field_content').val( $custom_field_content );

			if ( $value == 'departments' ) {
				if ( $showonform == '1' ) {
					$('div#wpgs_modal_main_content input#showonform_departments_1').attr('checked', 'checked');
					$('li.wpgs_field_list_default_department > div.list-departments').hide();
				} else if ( $showonform == '0' ) {
					$('div#wpgs_modal_main_content input#showonform_departments_0').attr('checked', 'checked');
					$('li.wpgs_field_list_default_department > div.list-departments').show();
				}
				$('div#wpgs_modal_main_content select#field_default_department').val( $default_department ).change();
			}

			// Change data-field att on edit button
			$('div#wpgs_modal_edit_fields a#wpgs_modal_edit_fields_submit').attr('data-group', $thisListId);
		}, 500);
	});

	// Process update
	$(document).on('click', '#wpgs_modal_edit_fields_submit', function() {
		var $this = $(this);
		var $dataGroup = $this.attr('data-group');

		// Get the field group list id
		var $thisList = $this.closest('div.wpgs-modal-container-wrapper');

		// Show pre-loader
		$thisList.find('.wpgs-modal-footer div.wt-loader').show();

		// Get inputs
		var $inputName = $thisList.find('.wpgs-modal-content input#field_name').val(),
			$inputLabel = $thisList.find('.wpgs-modal-content input#field_label').val(),
			$inputPlaceholder = $thisList.find('.wpgs-modal-content input#field_placeholder').val(),
			$inputRequired = $thisList.find('.wpgs-modal-content select#field_required').val(),
			$inputDescription = $thisList.find('.wpgs-modal-content textarea#field_description').val(),
			$inputErrorMessage = $thisList.find('.wpgs-modal-content textarea#field_error_message').val(),
			$min = $thisList.find('.wpgs-modal-content input#field_min').val(),
			$max = $thisList.find('.wpgs-modal-content input#field_max').val(),
			$options = $thisList.find('.wpgs-modal-content textarea#field_options').val(),
			$hidden_field_value = $thisList.find('.wpgs-modal-content input#field_value').val(),
			$custom_field_content = $thisList.find('.wpgs-modal-content textarea#field_content').val(),
			$colSize = $thisList.find('.wpgs-modal-content select#wpgs_field_list_colsize').val(),
			$fieldtoform = $thisList.find('.wpgs-modal-content select#wpgs_field_list_fieldtoform').val(),
			$showonticketview = $thisList.find('.wpgs-modal-content select#wpgs_field_list_showonticketview').val(),
			$addtoemail = $thisList.find('.wpgs-modal-content select#wpgs_field_list_addtoemail').val(),
			$login_required = $thisList.find('.wpgs-modal-content select#wpgs_field_list_login_required').val(),
			$inputType = $thisList.find('.wpgs-modal-content input#wpgs_this_field_input_type').val();

		if ( $options ) {
			var $optionsArray = $options.split(/\r?\n/);
		}

		// Departments
		var $deptShowonform = $thisList.find('.wpgs-modal-content input[name="showonform_departments"]:checked').val(),
			$deptDefaultDepartment = $thisList.find('.wpgs-modal-content select#field_default_department').val(),
			$deptShowonformYes = $('span#wpgs_texthelper_yes').html(),
			$deptShowonformNo = $('span#wpgs_texthelper_no').html();

		$('li#' + $dataGroup + ' input#wpgs_field_list_showonform').val( $deptShowonform );
		$('li#' + $dataGroup + ' select#wpgs_field_list_departments').val( $deptDefaultDepartment ).change();
		$('li#' + $dataGroup + ' input#wpgs_field_list_default_department').val( $deptDefaultDepartment );
		if ( $deptShowonform == '0' ) {
			$('li#' + $dataGroup + ' span#wpgs_form_field_label_showonform').html( $deptShowonformNo );
		} else {
			$('li#' + $dataGroup + ' span#wpgs_form_field_label_showonform').html( $deptShowonformYes );
		}

		// Update fields of this group
		$('li#' + $dataGroup + ' label').html($inputLabel);
		$('li#' + $dataGroup + ' input#wpgs_field_list_visible').attr('placeholder', $inputPlaceholder );
		$('li#' + $dataGroup + ' textarea#wpgs_field_list_visible').attr('placeholder', $inputPlaceholder );
		$('li#' + $dataGroup + ' input#wpgs_field_list_label').val( $inputLabel );
		$('li#' + $dataGroup + ' input#wpgs_field_list_placeholder').val( $inputPlaceholder );
		$('li#' + $dataGroup + ' textarea#wpgs_field_list_description').val( $inputDescription );
		$('li#' + $dataGroup + ' textarea#wpgs_field_list_error_message').val( $inputErrorMessage );

		$('li#' + $dataGroup + ' input#wpgs_field_list_min').val( $min );
		$('li#' + $dataGroup + ' input#wpgs_field_list_max').val( $max );
		$('li#' + $dataGroup + ' input#wpgs_field_list_hidden_value').val( $hidden_field_value );
		$('li#' + $dataGroup + ' textarea#wpgs_field_list_options').val( $options );
		$('li#' + $dataGroup + ' textarea#wpgs_field_list_customtext').val( $custom_field_content );
		$('li#' + $dataGroup + ' div.wpgs_field_list_visible_customcontent').html( $custom_field_content );

		if ( $inputType == 'select' ) {
			var $html_select = $('li#' + $dataGroup + ' select#wpgs_field_list_visible');
			$html_select.empty(); // remove old options
			if ( $options && $optionsArray.length !== 0 ) {
				$.each($optionsArray, function( index, value ) {
					$html_select.append($("<option></option>").attr("value", index).text(value));
				});
			}
		} else if ( $inputType == 'radio' ) {
			$html_radio = '';
			if ( $options && $optionsArray.length !== 0 ) {
				$.each($optionsArray, function( index, value ) {
					$html_radio += '<li><input name="demo_checkbox_' + $inputName + '" type="radio" id="' + $inputName + '_' + index + '" value="' + index + '"><label for="' + $inputName + '_' + index + '" class="wpgs-field-checkbox-label"> ' + value + '</label></li>';
				});
			}
			$('li#' + $dataGroup + ' ul.wpgs-field-checkbox').html($html_radio);
		} else if ( $inputType == 'checkbox' ) {
			$html_checkbox = '';
			if ( $options && $optionsArray.length !== 0 ) {
				$.each($optionsArray, function( index, value ) {
					$html_checkbox += '<li><input name="demo_checkbox_' + $inputName + '" type="checkbox" id="' + $inputName + '_' + index + '" value="' + index + '"><label for="' + $inputName + '_' + index + '" class="wpgs-field-checkbox-label"> ' + value + '</label></li>';
				});
			}
			$('li#' + $dataGroup + ' ul.wpgs-field-checkbox').html($html_checkbox);
		}

		if ($inputName) {
			$('li#' + $dataGroup + ' input#wpgs_field_list_name').val( $inputName );
			$('li#' + $dataGroup + ' span#wpgs_form_field_label_name').html( $inputName );
		}
		if ($inputRequired) {
			var $inputRequiredText = $thisList.find('.wpgs-modal-content select#field_required option:selected').text();
			$('li#' + $dataGroup + ' input#wpgs_field_list_required').val( $inputRequired );
			$('li#' + $dataGroup + ' span#wpgs_form_field_label_required').html( $inputRequiredText );
		}

		/** Column Size */
		if ( $inputType != 'hidden' ) {
			$('li#' + $dataGroup).removeClass('size-100').removeClass('size-50').removeClass('size-33-3');
			$('li#' + $dataGroup).addClass('size-' + $colSize);
			$('li#' + $dataGroup + ' input#wpgs_field_list_colsize').val( $colSize );
			$('li#' + $dataGroup + ' span#wpgs_form_field_label_colsize').html( $colSize + '%' );
		}

		$('li#' + $dataGroup + ' input#wpgs_field_list_fieldtoform').val( $fieldtoform );
		$('li#' + $dataGroup + ' input#wpgs_field_list_showonticketview').val( $showonticketview );
		$('li#' + $dataGroup + ' input#wpgs_field_list_addtoemail').val( $addtoemail );
		$('li#' + $dataGroup + ' input#wpgs_field_list_login_required').val( $login_required );
		/** End Column Size */
		$('li#' + $dataGroup).removeClass('wpgs_field_updating');

		setTimeout(function() {
			$thisList.find('.wpgs-modal-footer div.wt-loader').hide();
			wpgsModalClose();
		}, 500);
	});
	$(document).on('click', '.wpgs-add-edit-fields-modal a#wpgs_modal_close', function() {
		$('div.wpgs-add-edit-fields-modal div#wpgs_modal_main_content').html('');
		$('div.wpgs-add-edit-fields-modal select#wpgs_add_field_type').val('').change();
	});

	// Add/change Agent
	$.wpgsAddAgent();

	// Show hide SMTP options
	$(document).on('change', 'select#wpgs_select_mailer', function(event) {
        var $thisval = $(this).val();
		if ( $thisval == 'wp' ) {
			$('div#wpgs_settings_smtp_credentials').hide();
		}
		else
		{
			$('div#wpgs_settings_smtp_credentials').show();
		}
	});

	// Select/unselect all tickets
	$(document).on('change', 'input#guest_support_tickets_select_all', function(event) {
		if($(this).is(':checked')) {
            $('input#guest_support_tickets_select').prop('checked', true);
			$('a.guest-support-mass-delete').addClass('active');
        } else {
            $('input#guest_support_tickets_select').prop('checked', false);
			$('a.guest-support-mass-delete').removeClass('active');
        }
	});

	$('input#guest_support_tickets_select').change(function(){
        if ($('input#guest_support_tickets_select:checked').length > 0) {
            $('a.guest-support-mass-delete').addClass('active');
        } else {
            $('a.guest-support-mass-delete').removeClass('active');
        }
    });

	// Delete selected tickets
	$(document).on('click', 'a.guest-support-mass-delete', function(event) {
		let selectedValues = [];
		$('input#guest_support_tickets_select:checked').each(function(){
			selectedValues.push($(this).val());
		});

		if ( confirm("Are you sure? You can't undo this action.") ) {
			var post_vars = {
				'wpgs_handler': 'ajax',
				'request': 'delete_tickets',
				'ids': selectedValues
			};

			var data = $.post('', post_vars);
			data.done(function(reply_data) {
				location.reload();
			});
		}
	});	
});
