<?php
/**
 * @package     Guest Support
 * @author      RcaTheme.com <support@rcatheme.com>
 * @license     https://www.gnu.org/licenses/gpl-3.0.html GPLv3
 * @link        https://www.rcatheme.com
 * @copyright   2024 RcaTheme.com, All rights resered.
 */
defined('ABSPATH') or die;
// Check if user is in Admin area and can administrator
GuestSupportApp::verifyAdmin();

$type = isset( $_GET['type'] ) ? sanitize_text_field( $_GET['type'] ) : '';
$dept_id = isset( $_GET['dept_id'] ) ? (int) $_GET['dept_id'] : '';
$selected_forms = [];

$values = array(
    'dept_name' => '',
    'dept_agent' => 0,
    'dept_additional_emails' => '',
    'dept_additional_emails_type' => ''
);

if ( $type == 'add-new' )
{
    require_once WPGS_PLUGIN_DIR . 'includes/admin/departments-form.php';
}
elseif ( $type == 'edit' && $dept_id )
{
    $deptData = new GuestSupportDbquery();
    $department = $deptData->getDepartment( $dept_id );
    $selected_forms = $deptData->getSelectedFormidsbyDepartment( $dept_id );

    if ( empty( $department ) )
    {
        die("Invalid request.");
    }

    $values = array(
        'dept_name' => $department->name,
        'dept_agent' => $department->agent_id,
        'dept_additional_emails' => $department->additional_emails,
        'dept_additional_emails_type' => $department->additional_emails_type
    );
    require_once WPGS_PLUGIN_DIR . 'includes/admin/departments-form.php';
}
elseif ( !$type )
{
    require_once WPGS_PLUGIN_DIR . 'includes/admin/departments-list.php';
}
else
{
    require_once WPGS_PLUGIN_DIR . 'includes/admin/error.php';
}