<?php
/**
 * @package     Guest Support
 * @author      RcaTheme.com <support@rcatheme.com>
 * @license     https://www.gnu.org/licenses/gpl-3.0.html GPLv3
 * @link        https://www.rcatheme.com
 * @copyright   2024 RcaTheme.com, All rights resered.
 */
defined('ABSPATH') or die;
// Check if user is in Admin area and can administrator
GuestSupportApp::verifyAdmin();

$default_form_id = GuestSupportApp::getDefaultFormId();
?>
<div class="wrap">
    <h1 class="wp-heading-inline"><?php esc_html_e( 'Documentation and Support - Guest Support', 'guest-support' ); ?></h1>

    <div class="wpgs-wp-heading-spacer">&nbsp;</div>

    <div class="form-wrap wpgs-documentation">
        <div class="wpgs-settings-fields-content">
            <h3><?php esc_html_e( 'Documentation', 'guest-support' ); ?></h3>
			<ul>
				<li>Please follow the documentation located at <a href="https://www.rcatheme.com/docs/wordpress-plugins/guest-support-for-wordpress" target="_blank">https://www.rcatheme.com/docs/wordpress-plugins/guest-support-for-wordpress</a> for detailed instructions.</li>
			</ul>
			<h3><?php esc_html_e( 'Support', 'guest-support' ); ?></h3>
			<ul>
				<li>Please submit a support ticket on our platform using the following link: <a href="https://www.rcatheme.com/support-tickets" target="_blank">https://www.rcatheme.com/support-tickets</a>.</li>
			</ul>
			<div class="wpgs-spacer"></div>
			<h3>About RcaTheme.com</h3>
			<p>RcaTheme.com: Your Destination for Premium Joomla! Templates and WordPress Themes.</p>
			<p>Discover excellence in e-commerce with RcaTheme.com. Since 2012, we've been dedicated to delivering top-notch Joomla! templates and WordPress themes crafted for online success. Specializing in HikaShop, VirtueMart, and WooCommerce, our designs prioritize stability and security. We're committed to staying ahead, ensuring our code is always up-to-date and free from deprecated elements. Join customers worldwide who trust us for their e-commerce needs.</p>
			<h3>Our Products:</h3>
			<ol>
				<li><a href="https://www.rcatheme.com/joomla-extensions" target="_blank">Joomla! Extensions</a></li>
				<li><a href="https://www.rcatheme.com/hikashop-templates" target="_blank">HikaShop Templates</a></li>
				<li><a href="https://www.rcatheme.com/extensions-for-hikashop" target="_blank">Extensions for HikaShop</a></li>
				<li><a href="https://www.rcatheme.com/virtuemart-templates" target="_blank">VirtueMart Templates</a></li>
				<li><a href="https://www.rcatheme.com/extensions-for-virtuemart" target="_blank">Extensions for VirtueMart</a></li>
				<li><a href="https://www.rcatheme.com/wordpress-plugins" target="_blank">WordPress Plugins</a></li>
				<li><a href="https://www.rcatheme.com/woocommerce-themes" target="_blank">WooCommerce Themes</a></li>
				<li><a href="https://www.rcatheme.com/plugins-for-woocommerce" target="_blank">Plugins for WooCommerce</a></li>
				<li><a href="https://www.rcatheme.com/gantry-5-particles" target="_blank">Gantry Particles</a></li>
			</ol>
			<div class="wpgs-spacer"></div>
			<h3>RcaTheme Custom Services</h3>
			<h4>Tailored Solutions for Your Digital Success</h4>
			<p>Discover a suite of specialized services designed to meet your every digital need. Our dedicated team brings a wealth of expertise to the table, offering personalized solutions for a seamless online experience. Take advantage of our comprehensive range of custom services:</p>
			<ol>
				<li>Template and Theme Customization</li>
				<li>Custom Template Development</li>
				<li>Joomla! Extension Development (Component, Module, and Plugin)</li>
				<li>WordPress Themes and Plugins</li>
				<li>Joomla! Migration</li>
				<li>Site Transfer (Joomla! and WordPress) from one server to another</li>
				<li>Hosting Server Installation on Cloud or Dedicated Servers</li>
				<li>Resolution of Joomla! and WordPress Themes, Extensions, and Plugins Issues</li>
				<li>Custom Website Development</li>
				<li>Custom PHP and MySQL Based Software</li>
				<li>Tailored Billing and Accounting Software for Small to Medium-Sized Businesses</li>
			</ol>
			<p>Empower your online venture with our diverse expertise. Let us handle the intricacies while you focus on achieving digital success!</p>
			<p>Ready to get started? Contact us at <a href="https://www.rcatheme.com/contact-support" target="_blank">https://www.rcatheme.com/contact-support/</a> today for a personalized consultation.</p>
        </div>
    </div>
</div>