<?php
/**
 * @package     Guest Support
 * @author      RcaTheme.com <support@rcatheme.com>
 * @license     https://www.gnu.org/licenses/gpl-3.0.html GPLv3
 * @link        https://www.rcatheme.com
 * @copyright   2024 RcaTheme.com, All rights resered.
 */
defined('ABSPATH') or die;
// Check if user is in Admin area and can administrator
GuestSupportApp::verifyAdmin();

$type = isset( $_GET['type'] ) ? sanitize_text_field( $_GET['type'] ) : '';
$template_id = isset( $_GET['template_id'] ) ? (int) sanitize_text_field( $_GET['template_id'] ) : '';

$values = array(
    'id' => 0,
    'title' => '',
    'type' => '',
    'subject' => '',
    'template' => '',
    'lang' => '',
    'active' => 1
);

if ( $type == 'add-new' )
{
    require_once WPGS_PLUGIN_DIR . 'includes/admin/email-templates-form.php';
}
elseif ( $type == 'edit' && $template_id )
{
    $db = new GuestSupportDbquery();
    $template = $db->getEmailTemplate( $template_id );

    if ( empty( $template ) )
    {
        die("Invalid request.");
    }

    $values = array(
		'id' => $template->id,
		'title' => $template->title,
		'type' => $template->type,
		'subject' => $template->subject,
		'template' => $template->template,
		'lang' => $template->lang,
		'active' => $template->active
	);
    require_once WPGS_PLUGIN_DIR . 'includes/admin/email-templates-form.php';
}
elseif ( !$type )
{
    require_once WPGS_PLUGIN_DIR . 'includes/admin/email-templates-list.php';
}
else
{
    require_once WPGS_PLUGIN_DIR . 'includes/admin/error.php';
}