<?php
/**
 * @package     Guest Support
 * @author      RcaTheme.com <support@rcatheme.com>
 * @license     https://www.gnu.org/licenses/gpl-3.0.html GPLv3
 * @link        https://www.rcatheme.com
 * @copyright   2024 RcaTheme.com, All rights resered.
 */
defined('ABSPATH') or die;
// Check if user is in Admin area and can administrator
GuestSupportApp::verifyAdmin();

$type = isset( $_GET['type'] ) ? sanitize_text_field( $_GET['type'] ) : '';
$form_id = isset( $_GET['form_id'] ) ? (int) $_GET['form_id'] : 0;

$data = array(
    'form_name' => '',
    'recaptcha' => 0,
    'fileupload' => 1,
    'upload_filelimit' => 5,
    'upload_filesize' => 2000,
    'allowed_filetypes' => 'jpg,jpeg,png,pdf,zip',
    'fileupload_label' => 'Upload Files',
    'fileupload_help' => 'Maximum 5 files in jpg,jpeg,png,pdf,zip format and total images size not more than 2 MB.',
    'verify_email' => 0,
    'suggest_docs' => 0,
    'suggest_docs_cats' => '',
    'submit_text' => 'Create Ticket',
    'verify_otp_text' => 'Continue',
    'submit_class' => 'wpgs-button wpgs-submit-button',
    'input_class' => 'wpgs-input',
	'params' => []
);

if ( $type == 'add-new' )
{
    if ( GuestSupportApp::isPro() )
    {
		$departments = GuestSupportApp::getFormDepartments(0);
        require_once WPGS_PLUGIN_ADDON_DIR . 'includes/admin/forms-custom-inputs.php';
        require_once WPGS_PLUGIN_DIR . 'includes/admin/forms-form.php';
    }
    else
    {
        require_once WPGS_PLUGIN_DIR . 'includes/admin/error.php';
    }
}
elseif ( $type == 'edit' && $form_id )
{
    $db = new GuestSupportDbquery();
    $form = $db->getForm( $form_id );
    if( !empty( $form ) )
    {
        $data = array(
            'form_name' => $form->form_name,
            'recaptcha' => $form->recaptcha,
            'fileupload' => $form->fileupload,
            'upload_filelimit' => $form->upload_filelimit,
            'upload_filesize' => $form->upload_filesize,
            'allowed_filetypes' => $form->allowed_filetypes,
            'fileupload_label' => $form->fileupload_label,
            'fileupload_help' => $form->fileupload_help,
            'verify_email' => $form->verify_email,
            'suggest_docs' => $form->suggest_docs,
            'suggest_docs_cats' => $form->suggest_docs_cats,
            'submit_text' => $form->submit_text,
            'submit_class' => $form->submit_class,
            'verify_otp_text' => $form->verify_otp_text,
            'input_class' => $form->input_class,
            'params' => $form->params ? unserialize( $form->params ) : []
        );

        $formFields = unserialize( $form->form_fields );
        $departments = GuestSupportApp::getFormDepartments( $form_id );
        require_once WPGS_PLUGIN_DIR . 'includes/admin/forms-form.php';
    }
    else
    {
        require_once WPGS_PLUGIN_DIR . 'includes/admin/error.php';
    }
}
elseif ( !$type )
{
    $db = new GuestSupportDbquery();
    $forms = $db->listForms();
    require_once WPGS_PLUGIN_DIR . 'includes/admin/forms-list.php';
}
else
{
    require_once WPGS_PLUGIN_DIR . 'includes/admin/error.php';
}