<?php
/**
 * @package     Guest Support
 * @author      RcaTheme.com <support@rcatheme.com>
 * @license     https://www.gnu.org/licenses/gpl-3.0.html GPLv3
 * @link        https://www.rcatheme.com
 * @copyright   2024 RcaTheme.com, All rights resered.
 */

defined('ABSPATH') or die;
$page = isset( $_GET['page'] ) ? sanitize_text_field( $_GET['page'] ) : '';
$showguide = isset( $_GET['showguide'] ) ? (int) sanitize_text_field( $_GET['showguide'] ) : 0;
$admin_url = admin_url( 'admin.php?page=' );
$current_url = GuestSupportApp::currentUrl();
// die($current_url);

if ( is_admin() && strpos( $page, 'guest-support' ) !== false )
{
	$option = get_option('wpgs_setup_guide');

	if ( !$option )
	{
		// Guide Department
		$base_url = 'guest-support-departments';
		$edit_url = 'guest-support-departments&type=edit';

		if ( strpos( $current_url, $base_url ) === false )
		{
			wp_safe_redirect( $admin_url . 'guest-support-departments&showguide=1' );
		}
		if ( strpos( $current_url, $base_url ) !== false && strpos( $current_url, $edit_url ) === false && !$showguide  )
		{
			wp_safe_redirect( $admin_url . 'guest-support-departments&showguide=1' );
		}
	}
	elseif ( $option == 'forms' )
	{
		// Guide Forms
		$base_url = 'guest-support-forms';
		$edit_url = 'guest-support-forms&type=edit';

		if ( strpos( $current_url, $base_url ) === false )
		{
			wp_safe_redirect( $admin_url . 'guest-support-forms&showguide=1' );
		}
		if ( strpos( $current_url, $base_url ) !== false && strpos( $current_url, $edit_url ) === false && !$showguide  )
		{
			wp_safe_redirect( $admin_url . 'guest-support-forms&showguide=1' );
		}
	}
	elseif ( $option == 'settings' )
	{
		// Guide Forms
		$base_url = 'guest-support-settings';

		if ( strpos( $current_url, $base_url ) === false )
		{
			wp_safe_redirect( $admin_url . 'guest-support-settings&showguide=1' );
		}
		if ( strpos( $current_url, $base_url ) !== false && !$showguide  )
		{
			wp_safe_redirect( $admin_url . 'guest-support-settings&showguide=1' );
		}
	}
	elseif ( $option == 'email_settings' )
	{
		// Guide Forms
		$base_url = 'guest-support-email-settings';

		if ( strpos( $current_url, $base_url ) === false )
		{
			wp_safe_redirect( $admin_url . 'guest-support-email-settings&showguide=1' );
		}
		if ( strpos( $current_url, $base_url ) !== false && !$showguide  )
		{
			wp_safe_redirect( $admin_url . 'guest-support-email-settings&showguide=1' );
		}
	}
	elseif ( $option == 'email_templates' )
	{
		// Guide Email Templates
		$base_url = 'guest-support-email-templates';
		$edit_url = 'guest-support-email-templates&type=edit';

		if ( strpos( $current_url, $base_url ) === false )
		{
			wp_safe_redirect( $admin_url . 'guest-support-email-templates&showguide=1' );
		}
		if ( strpos( $current_url, $base_url ) !== false && strpos( $current_url, $edit_url ) === false && !$showguide  )
		{
			wp_safe_redirect( $admin_url . 'guest-support-email-templates&showguide=1' );
		}
	}
	elseif ( $option == 'shortcode' )
	{
		// Guide Shortcode Pages
		$redirectUrl = '';
		if ( !GuestSupportApp::getTicketFormPageId() )
		{
			$redirectUrl = $admin_url . 'guest-support-shortcodes&showguide=1&shortcode=form';
		}
		elseif ( !GuestSupportApp::getTicketPageId() )
		{
			$redirectUrl = $admin_url . 'guest-support-shortcodes&showguide=1&shortcode=ticket';
		}
		else
		{
			update_option('wpgs_setup_guide', 'done');
			wp_safe_redirect( $admin_url . 'guest-support-shortcodes' );
		}

		$base_url = 'guest-support-shortcodes';

		if ( $redirectUrl && strpos( $current_url, $base_url ) === false )
		{
			wp_safe_redirect( $redirectUrl );
		}
		if ( $redirectUrl && strpos( $current_url, $base_url ) !== false && !$showguide  )
		{
			wp_safe_redirect( $redirectUrl );
		}
	}
}